
(* ************************************** *
 *       Abstraction over theorems        * 
 *       from the theory of lists.        *
 * ************************************** *)

(* ************************* *)
(*      not_Cons_self        *)
(* ************************* *)

bind_thm ("abs_not_Cons_self", AbsTac.full_abs not_Cons_self);

(* ************************* *)
(*      not_Cons_self2       *)
(* ************************* *)

bind_thm ("abs_not_Cons_self2", AbsTac.full_abs not_Cons_self2);

(* ************************* *)
(*       neq_Nil_conv        *)
(* ************************* *)

bind_thm ("abs_neq_Nil_conv", AbsTac.full_abs neq_Nil_conv);

(* ************************* *)
(*       length_induct       *)
(* ************************* *)

bind_thm ("abs_length_induct", AbsTac.full_abs length_induct);

(* ************************* *)
(*       lists_mono          *)
(* ************************* *)

bind_thm ("abs_lists_mono", AbsTac.full_abs lists_mono);



(* ************************* *)
(*           listsE          *)
(* ************************* *)

bind_thm ("abs_listsE", AbsTac.full_abs listsE);

(* ************************* *)
(*       lists_IntI          *)
(* ************************* *)

bind_thm ("abs_lists_IntI", AbsTac.full_abs lists_IntI);

(* ************************* *)
(*      lists_Int_eq         *)
(* ************************* *)

bind_thm ("abs_lists_Int_eq", AbsTac.full_abs lists_Int_eq);

(* ************************* *)
(*   append_in_lists_conv    *)
(* ************************* *)

bind_thm ("abs_append_in_lists_conv", 
		AbsTac.full_abs append_in_lists_conv);

(* ************************* *)
(*      length_append        *)
(* ************************* *)

bind_thm ("abs_length_append", AbsTac.full_abs length_append);

(* ************************* *)
(*        length_map         *)
(* ************************* *)

bind_thm ("abs_length_map", AbsTac.full_abs length_map);

(* ************************* *)
(*        length_rev         *)
(* ************************* *)

bind_thm ("abs_length_rev", AbsTac.full_abs length_rev);

(* ************************* *)
(*         length_tl         *)
(* ************************* *)

bind_thm ("abs_length_tl", AbsTac.full_abs length_tl);

(* ************************* *)
(*       length_0_conv       *)
(* ************************* *)

bind_thm ("abs_length_0_conv", AbsTac.full_abs length_0_conv);

(* ************************* *)
(*   length_greater_0_conv   *)
(* ************************* *)

bind_thm ("abs_length_greater_0_conv", 
		AbsTac.full_abs length_greater_0_conv);

(* ************************* *)
(*      length_Suc_conv      *)
(* ************************* *)

bind_thm ("abs_Suc_conv", AbsTac.full_abs length_Suc_conv);

(* ************************* *)
(*        append_assoc       *)
(* ************************* *)

bind_thm ("abs_append_assoc", AbsTac.full_abs append_assoc);

(* ************************* *)
(*          append_Nil2      *)
(* ************************* *)

bind_thm ("abs_append_Nil2", AbsTac.full_abs append_Nil2);

(* ************************* *)
(*     append_is_Nil_conv    *)
(* ************************* *)

bind_thm ("abs_append_is_Nil_conv", AbsTac.full_abs append_is_Nil_conv);

(* ************************* *)
(*     Nil_is_append_conv    *)
(* ************************* *)

bind_thm ("abs_Nil_is_append_conv", AbsTac.full_abs Nil_is_append_conv);

(* ************************* *)
(*      append_self_conv     *)
(* ************************* *)

bind_thm ("abs_append_self_conv", AbsTac.full_abs append_self_conv);

(* ************************* *)
(*      self_append_conv     *)
(* ************************* *)

bind_thm ("abs_self_append_conv", AbsTac.full_abs self_append_conv);

(* ************************* *)
(*   append_eq_append_conv   *)
(* ************************* *)

bind_thm ("abs_append_eq_append_conv", 
		AbsTac.full_abs append_eq_append_conv);

(* ************************* *)
(*       same_append_eq      *)
(* ************************* *)

bind_thm ("abs_same_append_eq", AbsTac.full_abs same_append_eq);

(* ************************* *)
(*       append1_eq_conv     *)
(* ************************* *)

bind_thm ("abs_append1_eq_conv", AbsTac.full_abs append1_eq_conv);

(* ************************* *)
(*       append_same_eq      *)
(* ************************* *)

bind_thm ("abs_append_same_eq", AbsTac.full_abs append_same_eq);

(* ************************* *)
(*     append_self_conv2     *)
(* ************************* *)

bind_thm ("abs_append_self_conv2", AbsTac.full_abs append_self_conv2);

(* ************************* *)
(*     self_append_conv2     *)
(* ************************* *)

bind_thm ("abs_self_append_conv2", AbsTac.full_abs self_append_conv2);

(* ************************* *)
(*         hd_Cons_tl        *)
(* ************************* *)

bind_thm ("abs_hd_Cons_tl", AbsTac.full_abs hd_Cons_tl);

(* ************************* *)
(*          hd_append        *)
(* ************************* *)

bind_thm ("abs_hd_append", AbsTac.full_abs hd_append);

(* ************************* *)
(*          hd_append2       *)
(* ************************* *)

bind_thm ("abs_hd_append2", AbsTac.full_abs hd_append2);

(* ************************* *)
(*          tl_append        *)
(* ************************* *)

bind_thm ("abs_tl_append", AbsTac.full_abs tl_append);

(* ************************* *)
(*          tl_append2       *)
(* ************************* *)

bind_thm ("abs_tl_append2", AbsTac.full_abs tl_append2);

(* ************************* *)
(*       eq_Nil_appendI      *)
(* ************************* *)

bind_thm ("abs_eq_Nil_appendI", AbsTac.full_abs eq_Nil_appendI);

(* ************************* *)
(*      Cons_eq_appendI      *)
(* ************************* *)

bind_thm ("abs_Cons_eq_appendI", AbsTac.full_abs Cons_eq_appendI);

(* ************************* *)
(*     append_eq_appendI     *)
(* ************************* *)

bind_thm ("abs_append_eq_appendI", 
		AbsTac.full_abs append_eq_appendI);

(* ************************* *)
(*          map_ext          *)
(* ************************* *)

bind_thm ("abs_map_ext", AbsTac.full_abs map_ext);

(* ************************* *)
(*         map_ident         *)
(* ************************* *)

bind_thm ("abs_map_ident", AbsTac.full_abs map_ident);

(* ************************* *)
(*         map_append        *)
(* ************************* *)

bind_thm ("abs_map_append", AbsTac.full_abs map_append);

(* ************************* *)
(*         map_compose       *)
(* ************************* *)

bind_thm ("abs_map_compose", AbsTac.full_abs map_compose);

(* ************************* *)
(*         rev_map           *)
(* ************************* *)

bind_thm ("abs_rev_map", AbsTac.full_abs rev_map);

(* ************************* *)
(*        map_eq_conv        *)
(* ************************* *)

(* *** NOT FOUND! 
bind_thm ("abs_map_eq_conv", AbsTac.full_abs map_eq_conv);
*)

(* ************************* *)
(*         map_cong          *)
(* ************************* *)

bind_thm ("abs_map_cong", AbsTac.full_abs map_cong);

(* ************************* *)
(*      map_is_Nil_conv      *)
(* ************************* *)

bind_thm ("abs_map_is_Nil_conv", AbsTac.full_abs map_is_Nil_conv);

(* ************************* *)
(*       Nil_is_map_conv     *)
(* ************************* *)

bind_thm ("abs_Nil_is_map_conv", AbsTac.full_abs Nil_is_map_conv);

(* ************************* *)
(*       map_eq_Cons         *)
(* ************************* *)

bind_thm ("abs_map_eq_Cons", AbsTac.full_abs map_eq_Cons);

(* ************************* *)
(*    map_injective          *)
(* ************************* *)
(* FAILS !!!
bind_thm ("abs_map_injective", AbsTac.full_abs map_injective);
*)

(* ************************* *)
(*         inj_mapI          *)
(* ************************* *)

bind_thm ("abs_inj_mapI", AbsTac.full_abs inj_mapI);

(* ************************* *)
(*         inj_mapD          *)
(* ************************* *)

bind_thm ("abs_inj_mapD", AbsTac.full_abs inj_mapD);

(* ************************* *)
(*         inj_map           *)
(* ************************* *)

bind_thm ("abs_inj_map", AbsTac.full_abs inj_map);

(* ************************* *)
(*        rev_append         *)
(* ************************* *)

bind_thm ("abs_rev_append", AbsTac.full_abs rev_append);

(* ************************* *)
(*      rev_rev_ident        *)
(* ************************* *)

bind_thm ("abs_rev_rev_ident", AbsTac.full_abs rev_rev_ident);

(* ************************* *)
(*     rev_is_Nil_conv       *)
(* ************************* *)

bind_thm ("abs_rev_is_Nil_conv", AbsTac.full_abs rev_is_Nil_conv);

(* ************************* *)
(*     Nil_is_rev_conv       *)
(* ************************* *)

bind_thm ("abs_Nil_is_rev_conv", AbsTac.full_abs Nil_is_rev_conv);

(* ************************* *)
(*     rev_is_rev_conv       *)
(* ************************* *)

bind_thm ("abs_rev_is_rev_conv", AbsTac.full_abs rev_is_rev_conv);

(* ************************* *)
(*         rev_induct        *)
(* ************************* *)

bind_thm ("abs_rev_induct", AbsTac.full_abs rev_induct);


(* ************************* *)
(*     rev_exhaust_aux       *)
(* ************************* *)
(* REMOVED THEOREM :
bind_thm ("abs_rev_exhaust_aux", AbsTac.full_abs rev_exhaust_aux);
*)

(* ************************* *)
(*         rev_exhaust       *)
(* ************************* *)

bind_thm ("abs_rev_exhaust", AbsTac.full_abs rev_exhaust);

(* ************************* *)
(*         rev_cases       *)
(* ************************* *)

(* ERROR
bind_thm ("abs_rev_cases", AbsTac.full_abs rev_cases);
*)

(* ************************* *)
(*         finite_set        *)
(* ************************* *)

bind_thm ("abs_finite_set", AbsTac.full_abs finite_set);

(* ************************* *)
(*         set_append        *)
(* ************************* *)

bind_thm ("abs_set_append", AbsTac.full_abs set_append);

(* ************************* *)
(*      set_subset_Cons      *)
(* ************************* *)

bind_thm ("abs_set_subset_Cons", AbsTac.full_abs set_subset_Cons);

(* ************************* *)
(*         set_empty         *)
(* ************************* *)

bind_thm ("abs_set_empty", AbsTac.full_abs set_empty);

(* ************************* *)
(*          set_rev          *)
(* ************************* *)

bind_thm ("abs_set_rev", AbsTac.full_abs set_rev);

(* ************************* *)
(*           set_map         *)
(* ************************* *)

bind_thm ("abs_set_map", AbsTac.full_abs set_map);

(* ************************* *)
(*         set_filter        *)
(* ************************* *)

bind_thm ("abs_set_filter", AbsTac.full_abs set_filter);

(* ************************* *)
(*          set_upt          *)
(* ************************* *)

bind_thm ("abs_set_upt", AbsTac.full_abs set_upt);

(* ************************* *)
(*    in_set_conv_decomp     *)
(* ************************* *)

bind_thm ("abs_in_set_conv_decomp", 
		AbsTac.full_abs in_set_conv_decomp);
(* ************************* *)
(*    in_lists_conv_set      *)
(* ************************* *)

bind_thm ("abs_in_lists_conv_set", 
		AbsTac.full_abs in_lists_conv_set);



(* ************************* *
 * ************************* *
   New lemmas Isabelle 2003
 * ************************* *
 * ************************* *)


(* ************************* *)
(*       in_listsD           *)
(* ************************* *)

bind_thm ("abs_listsD", AbsTac.full_abs in_listsD);

(* ************************* *)
(*       in_listsI           *)
(* ************************* *)

bind_thm ("abs_listsE", AbsTac.full_abs in_listsI); 

(* *** unbound variable or constructor: finite_list *** *)
bind_thm("abs_finite_list", AbsTac.full_abs (thm "finite_list"));

bind_thm ("abs_set_mem_eq", AbsTac.full_abs set_mem_eq);

bind_thm ("abs_list_all_conv", AbsTac.full_abs list_all_conv);

bind_thm ("abs_list_all_append", AbsTac.full_abs list_all_append);

bind_thm ("abs_filter_append", AbsTac.full_abs filter_append);

bind_thm ("abs_filter_filter", AbsTac.full_abs filter_filter);

bind_thm ("abs_filter_True", AbsTac.full_abs filter_True);

bind_thm ("abs_filter_False", AbsTac.full_abs filter_False); 

bind_thm ("abs_length_filter", AbsTac.full_abs length_filter);

bind_thm ("abs_filter_is_subset", AbsTac.full_abs filter_is_subset);

bind_thm ("abs_concat_append", AbsTac.full_abs concat_append);

bind_thm ("abs_concat_eq_Nil", AbsTac.full_abs concat_eq_Nil_conv);

bind_thm ("abs_Nil_eq_concat_conv", AbsTac.full_abs Nil_eq_concat_conv);

bind_thm ("abs_set_concat", AbsTac.full_abs set_concat);

bind_thm ("abs_map_concat", AbsTac.full_abs map_concat);

bind_thm ("abs_filter_concat", AbsTac.full_abs filter_concat);

bind_thm ("abs_rev_concat", AbsTac.full_abs rev_concat);

bind_thm ("abs_nth_Cons_0", AbsTac.full_abs nth_Cons_0);

bind_thm ("abs_nth_Cons_Suc", AbsTac.full_abs nth_Cons_Suc);

bind_thm ("abs_nth_append", AbsTac.full_abs nth_append);

bind_thm ("abs_nth_map", AbsTac.full_abs nth_map);

bind_thm ("abs_set_conv_nth", AbsTac.full_abs set_conv_nth);

bind_thm ("abs_list_ball_nth", AbsTac.full_abs list_ball_nth);

bind_thm ("abs_nth_mem", AbsTac.full_abs nth_mem);

bind_thm ("abs_all_nth_imp_all_set", 
   AbsTac.full_abs all_nth_imp_all_set);

bind_thm ("abs_all_set_conv_all_nth",
   AbsTac.full_abs all_set_conv_all_nth);

bind_thm ("abs_length_list_update",
   AbsTac.full_abs length_list_update);

bind_thm ("abs_nth_list_update",
   AbsTac.full_abs nth_list_update);

bind_thm ("abs_nth_list_update_eq",
   AbsTac.full_abs nth_list_update_eq);

bind_thm ("abs_nth_list_update_neq",
   AbsTac.full_abs nth_list_update_neq); 

bind_thm ("abs_list_update_overwrite",
   AbsTac.full_abs list_update_overwrite);

bind_thm ("abs_list_update_same_conv",
   AbsTac.full_abs list_update_same_conv);

bind_thm ("abs_update_zip", AbsTac.full_abs update_zip);

bind_thm ("abs_update_subset_insert",
   AbsTac.full_abs set_update_subset_insert);

bind_thm ("abs_set_update_subsetI",
   AbsTac.full_abs set_update_subsetI);

bind_thm ("abs_last_snoc", AbsTac.full_abs last_snoc);

bind_thm ("abs_butlast_snoc", AbsTac.full_abs butlast_snoc);

bind_thm ("abs_length_butlast", AbsTac.full_abs length_butlast);

bind_thm ("abs_butlast_append", AbsTac.full_abs butlast_append);

bind_thm ("abs_append_butlast_last_id", 
   AbsTac.full_abs append_butlast_last_id);

bind_thm ("abs_in_set_butlastD",
   AbsTac.full_abs in_set_butlastD);

bind_thm ("abs_in_set_butlast_appendI",
   AbsTac.full_abs in_set_butlast_appendI);

bind_thm ("abs_take_0", AbsTac.full_abs take_0);

bind_thm ("abs_drop_0", AbsTac.full_abs drop_0);

bind_thm ("abs_take_Suc_Cons", AbsTac.full_abs take_Suc_Cons);

bind_thm ("abs_drop_Suc_Cons", AbsTac.full_abs drop_Suc_Cons); 

(* *** unbound variable or constructor: take_Suc_conv_app_nth *** *)
bind_thm ("abs_take_Suc_conv_app_nth",
    AbsTac.full_abs (thm "take_Suc_conv_app_nth"));

bind_thm ("abs_length_take", AbsTac.full_abs length_take);

bind_thm ("abs_length_drop", AbsTac.full_abs length_drop);

bind_thm ("abs_take_all", AbsTac.full_abs take_all);

bind_thm ("abs_drop_all", AbsTac.full_abs drop_all);

bind_thm ("abs_take_append", AbsTac.full_abs take_append);

bind_thm ("abs_drop_append", AbsTac.full_abs drop_append);

bind_thm ("abs_take_take", AbsTac.full_abs take_take);

bind_thm ("abs_drop_drop", AbsTac.full_abs drop_drop); 

bind_thm ("abs_take_drop", AbsTac.full_abs take_drop);

bind_thm ("abs_append_take_drop_id", 
   AbsTac.full_abs append_take_drop_id);

bind_thm ("abs_take_map", AbsTac.full_abs take_map);

bind_thm ("abs_drop_map", AbsTac.full_abs drop_map);

bind_thm ("abs_rev_take", AbsTac.full_abs rev_take);

bind_thm ("abs_rev_drop", AbsTac.full_abs rev_drop);

bind_thm ("abs_nth_take", AbsTac.full_abs nth_take);

bind_thm ("abs_nth_drop", AbsTac.full_abs nth_drop);

bind_thm ("abs_append_eq_conv_conj", 
   AbsTac.full_abs append_eq_conv_conj);

bind_thm ("abs_takeWhile_dropWhile_id", 
   AbsTac.full_abs takeWhile_dropWhile_id);

bind_thm ("abs_takeWhile_append1", 
   AbsTac.full_abs takeWhile_append1);

bind_thm ("abs_takeWhile_append2", 
   AbsTac.full_abs takeWhile_append2);

bind_thm ("abs_takeWhile_tail",
   AbsTac.full_abs takeWhile_tail);

bind_thm ("abs_dropWhile_append1",
   AbsTac.full_abs dropWhile_append1);

bind_thm ("abs_dropWhile_append2",
   AbsTac.full_abs dropWhile_append2);

bind_thm ("abs_set_take_whileD",
   AbsTac.full_abs set_take_whileD);

(* *** unbound variable or constructor: takeWhile_eq_all_conv *** *)
bind_thm("abs_takeWhile_eq_all_conv",
   AbsTac.full_abs (thm "takeWhile_eq_all_conv"));


(* *** Error: unbound variable or constructor: dropWhile_eq_Nil_conv *** *)
bind_thm("abs_dropWhile_eq_Nil_conv",
   AbsTac.full_abs (thm "dropWhile_eq_Nil_conv"));

(* *** Error: unbound variable or constructor: dropWhile_eq_Cons_conv *** *)
bind_thm("abs_dropWhile_eq_Cons_conv",
   AbsTac.full_abs (thm "dropWhile_eq_Cons_conv"));


(* ********************************
Exception TYPE raised:
Illegal type for constant "AbsList.list.Cons" :: "['a * 'b, nutyp1] =>
yp1"
  ********************************
AbsTac.full_abs zip_Nil;
*)

bind_thm ("abs_zip_Cons_Cons",
   AbsTac.full_abs zip_Cons_Cons);

bind_thm ("abs_length_zip",
   AbsTac.full_abs length_zip);

bind_thm ("abs_zip_append1",
   AbsTac.full_abs zip_append1);

bind_thm ("abs_zip_append2",
   AbsTac.full_abs zip_append2);

bind_thm ("abs_zip_append",
   AbsTac.full_abs zip_append);

bind_thm ("abs_zip_rev",
   AbsTac.full_abs zip_rev);

bind_thm ("abs_nth_zip",
   AbsTac.full_abs nth_zip);

bind_thm ("abs_set_zip",
   AbsTac.full_abs set_zip);

bind_thm ("abs_zip_update",
   AbsTac.full_abs zip_update);

bind_thm ("abs_zip_replicate",
   AbsTac.full_abs zip_replicate);

bind_thm ("abs_list_all2_lengthD",
   AbsTac.full_abs list_all2_lengthD);

bind_thm ("abs_list_all2_Nil",
   AbsTac.full_abs list_all2_Nil); 

bind_thm ("abs_list_all2_Nil2",
   AbsTac.full_abs list_all2_Nil2);

bind_thm ("abs_list_all2_Cons",
   AbsTac.full_abs list_all2_Cons);

bind_thm ("abs_list_all2_Cons1",
   AbsTac.full_abs list_all2_Cons1);

bind_thm ("abs_list_all2_Cons2",
   AbsTac.full_abs list_all2_Cons2);

bind_thm ("abs_list_all2_rev",
   AbsTac.full_abs list_all2_rev);

(* *** Error: unbound variable or constructor: list_all2_rev1 *** *)
bind_thm ("abslist_all2_rev1",
          AbsTac.full_abs (thm "list_all2_rev1"));

bind_thm ("abs_list_all2_append1",
   AbsTac.full_abs list_all2_append1);

bind_thm ("abs_list_all2_append2",
   AbsTac.full_abs list_all2_append2);

(* *** Error: unbound variable or constructor: list_all2_append *** *)
bind_thm ("abs_list_all2_append",
   AbsTac.full_abs (thm "list_all2_append"));

(* *** Error: unbound variable or constructor: list_all2_appendI *** *)
bind_thm ("abs_list_all2_appendI",
   AbsTac.full_abs (thm "list_all2_appendI"));


bind_thm ("abs_list_all2_conv_all_nth",
   AbsTac.full_abs list_all2_conv_all_nth);

bind_thm ("abs_list_all2_trans",
   AbsTac.full_abs list_all2_trans);

(* *************************************** *
 *  Error: unbound variable or constructor *
 * *************************************** *)

bind_thm("abs_list_all2_all_nthI",
   AbsTac.full_abs (thm "list_all2_all_nthI"));

bind_thm("abs_list_all2_nthD",
   AbsTac.full_abs (thm "list_all2_nthD"));

bind_thm("abs_list_all2_map1",
   AbsTac.full_abs (thm "list_all2_map1"));

bind_thm("abs_list_all2_map2",
   AbsTac.full_abs (thm "list_all2_map2"));

bind_thm("abs_list_all2_refl",
   AbsTac.full_abs (thm "list_all2_refl"));

bind_thm("abs_list_all2_update_cong",
   AbsTac.full_abs (thm "list_all2_update_cong"));

bind_thm("abs_list_all2_update_cong2",
   AbsTac.full_abs (thm "list_all2_update_cong2"));

bind_thm("abs_list_all2_dropI",
   AbsTac.full_abs (thm "list_all2_dropI"));

bind_thm("abs_list_all2_mono",
   AbsTac.full_abs (thm "list_all2_mono"));

(* ************ *)

bind_thm ("abs_foldl_append",
   AbsTac.full_abs foldl_append);

bind_thm ("abs_start_le_sum",
   AbsTac.full_abs start_le_sum);

bind_thm ("abs_elem_le_sum",
   AbsTac.full_abs elem_le_sum);

bind_thm ("abs_sum_eq_0_conv",
   AbsTac.full_abs sum_eq_0_conv); 

bind_thm ("abs_upt_rec",
   AbsTac.full_abs upt_rec);

bind_thm ("abs_upt_conv_Nil",
   AbsTac.full_abs upt_conv_Nil);

bind_thm ("abs_upt_Suc_append",
   AbsTac.full_abs upt_Suc_append);

bind_thm ("abs_upt_conv_Cons",
   AbsTac.full_abs upt_conv_Cons);

bind_thm ("abs_upt_add_eq_append",
   AbsTac.full_abs upt_add_eq_append);

bind_thm ("abs_length_upt",
   AbsTac.full_abs length_upt); 

bind_thm ("abs_nth_upt",
   AbsTac.full_abs nth_upt); 

bind_thm ("abs_take_upt",
   AbsTac.full_abs take_upt); 

bind_thm ("abs_map_Suc_upt",
   AbsTac.full_abs map_Suc_upt);

bind_thm ("abs_nth_map_upt",
   AbsTac.full_abs nth_map_upt);

bind_thm ("abs_nth_take_lemma",
   AbsTac.full_abs nth_take_lemma);

bind_thm ("abs_nth_equalityI",
   AbsTac.full_abs nth_equalityI);

(* *** Error: unbound variable or constructor: list_all2_antisym *** *)
bind_thm ("abs_list_all2_antisym",
   AbsTac.full_abs (thm "list_all2_antisym"));

bind_thm ("abs_take_equalityI",
   AbsTac.full_abs take_equalityI);

bind_thm ("abs_distinct_append",
   AbsTac.full_abs distinct_append); 

bind_thm ("abs_set_remdups",
   AbsTac.full_abs set_remdups); 

bind_thm ("abs_distinct_remdups",
   AbsTac.full_abs distinct_remdups);

bind_thm ("abs_distinct_filter",
   AbsTac.full_abs distinct_filter);

(* *** Error: unbound variable or constructor: distinct_conv_nth *** *)
bind_thm ("abs_distinct_conv_nth", 
   AbsTac.full_abs (thm "distinct_conv_nth"));

bind_thm ("abs_length_replicate",
   AbsTac.full_abs length_replicate);

bind_thm ("abs_map_replicate",
   AbsTac.full_abs map_replicate);

bind_thm ("abs_replicate_app_Cons_same",
   AbsTac.full_abs replicate_app_Cons_same);

bind_thm ("abs_rev_replicate",
   AbsTac.full_abs rev_replicate);

bind_thm ("abs_replicate_add",
   AbsTac.full_abs replicate_add);

bind_thm ("abs_hd_replicate",
   AbsTac.full_abs hd_replicate);

bind_thm ("abs_tl_replicate",
   AbsTac.full_abs tl_replicate);

bind_thm ("abs_last_replicate",
   AbsTac.full_abs last_replicate);

bind_thm ("abs_nth_replicate",
   AbsTac.full_abs nth_replicate);

(* *** Error: unbound variable or constructor: set_replicate_Suc *** *)
bind_thm ("abs_set_replicate_Suc",
   AbsTac.full_abs (thm "set_replicate_Suc"));

bind_thm ("abs_set_replicate",
   AbsTac.full_abs set_replicate);

bind_thm ("abs_set_replicate_conv_if",
   AbsTac.full_abs set_replicate_conv_if);

bind_thm ("abs_in_set_replicateD",
   AbsTac.full_abs in_set_replicateD);

bind_thm ("abs_wf_lexn",
   AbsTac.full_abs wf_lexn);

bind_thm ("abs_lexn_length",
   AbsTac.full_abs lexn_length);

bind_thm ("abs_wf_lex",
   AbsTac.full_abs wf_lex);

bind_thm ("abs_lexn_conv",
   AbsTac.full_abs lexn_conv);

bind_thm ("abs_lex_conv",
   AbsTac.full_abs lex_conv);

bind_thm ("abs_wf_lexico",
   AbsTac.full_abs wf_lexico);

bind_thm ("abs_lexico_conv",
   AbsTac.full_abs lexico_conv);

bind_thm ("abs_Nil_notin_lex",
   AbsTac.full_abs Nil_notin_lex);

bind_thm ("abs_Nil2_notin_lex",
   AbsTac.full_abs Nil2_notin_lex);

bind_thm ("abs_Cons_in_lex",
   AbsTac.full_abs Cons_in_lex);

bind_thm ("abs_sublist_empty",
   AbsTac.full_abs sublist_empty);

bind_thm ("abs_sublist_nil",
   AbsTac.full_abs sublist_nil);

bind_thm ("abs_sublist_shift_lemma",
   AbsTac.full_abs sublist_shift_lemma);

bind_thm ("abs_sublist_append",
   AbsTac.full_abs sublist_append);

bind_thm ("abs_sublist_Cons",
   AbsTac.full_abs sublist_Cons);

bind_thm ("abs_sublist_singleton",
   AbsTac.full_abs sublist_singleton);

bind_thm ("abs_sublist_upt_eq_take",
   AbsTac.full_abs sublist_upt_eq_take);

bind_thm ("abs_take_Cons'",
   AbsTac.full_abs take_Cons');

bind_thm ("abs_drop_Cons'",
   AbsTac.full_abs drop_Cons');

bind_thm ("abs_nth_Cons'",
   AbsTac.full_abs nth_Cons');

(* lemmas [simp] = take_Cons'[of "number_of v",standard] *)








writeln "\n\nAbstraction complete\n\n";
