ArrayStack = DStruct + 

(* A stack implemented by stackpointer plus a map of stackpointers to data *)
(* The stackpointer always points to the next _free_ cell *)

types globalstate = "int* int"
      astate = "nat* (nat ~=> int)"
      astack = "(globalstate, astate) dstruct"

constdefs 
  apush :: "((globalstate* astate)* (globalstate* astate)) set" 
           "apush == {(((i, out), (p, a)), ((i', out'), (p', a'))). 
                      (i', out')= (i, out) & p'= p+ 1 & a'= a(p |-> i)}" 

  apop  :: "((globalstate* astate)* (globalstate* astate)) set" 
           "apop  == {((g, (p, a)), (g', (p', a'))). 
                       g'= g & p'= p- 1 & a'= a}"

  atop  :: "((globalstate* astate)* (globalstate* astate)) set" 
           "atop  == {(((i, out), (p, a)), ((i', out'), (p', a'))). 
                       i'= i & out'= the (a (p - 1)) & p'= p & a'= a}"

  aempty :: "(globalstate* astate) set"
            "aempty == {(g, l). l= (0, empty)}"
  
  aops  :: "i=> ((globalstate* astate)* (globalstate* astate)) set"
           "aops i == case i of push => apush | pop => apop | top => atop"
   
  as :: astack
        "as == (aempty, aops)"


(* Auxiliary: elements of an array stack *)

consts
  elems :: "[nat, nat ~=> int]=> int list"

primrec
  "elems 0 a       = []"
  "elems (Suc k) a = the (a k) # (elems k a)" 

end
