

(* Do this:  *)
(*
proofs := 2;
*)
(* --- Part I: Lemmas ----------------------------------------------- *)

(* We need a lemma about lists. *)
val [prem]= goal List.thy "xs ~= [] ==> hd xs= xs!0";
br trans 1;
br subst 2;
back();back();back();
br hd_Cons_tl 2;
br prem 2;
auto();
qed "hd_0th";

(* NOT NEEDED ANYMORE 
(* --- PC2 for top -------------------------------------------------- *)
goal thy "!!a b aa ba bb ab bc bd.[| (((aa, ba), bb), (ab, bc), bd) : ltop; (bb, a, b) : r |] ==> ((aa, ba), a, b) : Domain atop";
by (rewrite_goals_tac [ltop_def, atop_def, r_def]);
auto();
qed "pc2_top";

(* --- PC2 for pop and push ----------------------------------------- *)
goal thy "!!a b aa ba bb ab bc bd.[| (((aa, ba), bb), (ab, bc), bd) : lpop; (bb, a, b) : r |] ==> ((aa, ba), a, b) : Domain apop";
by (rewrite_goals_tac [lpop_def, apop_def,r_def]);
auto();
qed "pc2_pop";

goal thy "!!a b aa ba bb ab bc bd. [| (((aa, ba), bb), (ab, bc), bd) : lpush; (bb, a, b) : r |] ==> ((aa, ba), a, b) : Domain apush";
by (rewrite_goals_tac [lpush_def, apush_def, r_def]);
auto();
qed "pc2_push";


(* --- PC3 for top -------------------------------------------------- *)
goal thy "!!a b aa ba ab bb ac bc bd ad be bf. [| (((ac, bc), bd), (ad, be), bf) : ltop; (bd, a, b) : r; (((ac, bc), a, b), (ab, bb), aa, ba) : atop |] ==> EX a'. (((ac, bc), bd), (ab, bb), a') : ltop & (a', aa, ba) : r";
by (rewrite_goals_tac [ltop_def, atop_def, r_def]);
auto();
be allE 1;
be impE 1;
br trans 2;
br (hd_0th RS sym) 3;
auto();
qed "pc3_top";

(* --- PC3 for push ------------------------------------------------ *)
goal thy "!!a b aa ba ab bb ac bc bd ad be bf.[| (((ac, bc), bd), (ad, be), bf) : lpush; (bd, a, b) : r; (((ac, bc), a, b), (ab, bb), aa, ba) : apush |] ==> EX a'. (((ac, bc), bd), (ab, bb), a') : lpush & (a', aa, ba) : r";
by (rewrite_goals_tac [apush_def, lpush_def]);
auto();
br (r_same_elems RS iffD2) 1;
br (elems_Cons RS sym) 1;
br (r_same_elems RS iffD1 RS sym) 1;
ba 1;
qed "pc3_push";


(* --- PC3 for pop ------------------------------------------------- *)
goal thy "!!a b aa ba ab bb ac bc bd ad be bf. [| (((ac, bc), bd), (ad, be), bf) : lpop; (bd, a, b) : r; (((ac, bc), a, b), (ab, bb), aa, ba) : apop |] ==> EX a'. (((ac, bc), bd), (ab, bb), a') : lpop & (a', aa, ba) : r";
by (rewrite_goals_tac [apop_def, lpop_def]);
auto();
br (r_same_elems RS iffD2) 1;
br (elems_Tl RS sym) 1;
br (r_same_elems RS iffD1 RS sym) 1;
ba 1;
qed "pc3_pop";

********************************************* *)


(* --- Part II: The main refinement -------------------------------- *)



goal thy "EX r. let cinit = fst as; cops = snd as; ainit = fst ls; aops = snd ls in (ALL (g, c):cinit. EX a. (g, a) : ainit & (a, c) : r) & (ALL i c. ALL (g, a):Domain (aops i). (a, c) : r --> (g, c) : Domain (cops i)) & (ALL i c c' g'. ALL (g, a):Domain (aops i). (a, c) : r & ((g, c), g', c') : cops i --> (EX a'. ((g, a), g', a') : aops i & (a', c') : r))";
br exI 1;
by (instantiate_tac [("r", "r")]);
bw Let_def;
br conjI 1;
br conjI 2;

(* --- PC1: ---------- *)
(* by (SELECT_GOAL (rewrite_goals_tac [pc1_def, r_def]) 1); *)
by (SELECT_GOAL (rewrite_goals_tac [r_def]) 1);
by (rewrite_goals_tac [ls_def, as_def]);
by (rewrite_goals_tac [aempty_def, lempty_def]);
by(Simp_tac 1);
(* --- This proves PC1. We're now at Level 7, 2 subgoals left --- *)

auto();
by (rewrite_tac [lops_def, aops_def]);

by (case_tac "i" 1);
by (case_tac "i" 4);
auto();

(* Now we can tick them off one by one *)
(* by (rewrite_tac [pc2_def, pc3_def]); auto(); *)
(* br pc2_push 1;auto(); *)
by (SELECT_GOAL (rewrite_goals_tac [lpush_def, apush_def, r_def]) 1);
auto();
(* br pc2_pop 1;auto(); *)
by (SELECT_GOAL (rewrite_goals_tac [lpop_def, apop_def,r_def]) 1);
auto();
(* br pc2_top 1;auto(); *)
by (SELECT_GOAL (rewrite_goals_tac [ltop_def, atop_def, r_def]) 1);
auto();
(* br pc3_push 1;auto(); *)
by (SELECT_GOAL (rewrite_goals_tac [apush_def, lpush_def]) 1);
auto();
br (r_same_elems RS iffD2) 1;
br (elems_Cons RS sym) 1;
br (r_same_elems RS iffD1 RS sym) 1;
ba 1;
(* br pc3_pop 1;auto(); *)
by (SELECT_GOAL (rewrite_goals_tac [apop_def, lpop_def]) 1);
auto();
br (r_same_elems RS iffD2) 1;
br (elems_Tl RS sym) 1;
br (r_same_elems RS iffD1 RS sym) 1;
ba 1;
(* br pc3_top 1;auto(); *)
by (SELECT_GOAL (rewrite_goals_tac [ltop_def, atop_def, r_def]) 1);
auto();
be allE 1;
be impE 1;
br trans 2;
br (hd_0th RS sym) 3;
auto();
qed "pc_thm";


(* REAL GOAL *)
goal thy "as [= ls";
by (rewrite_goals_tac [refines_def, pc1_def, pc2_def, pc3_def]);
br pc_thm 1;
qed "stack_ref";

(* --- PC2 for top -------------------------------------------------- *)
(* OLD
goal thy "pc2 r ltop atop";
by (rewrite_goals_tac [pc2_def, ltop_def, atop_def]);
bw r_def;
auto();
(* 
br exI 1;
auto();
be allE 1;
be impE 1;
auto();
br trans 1;
br hd_0th 1;
auto();
*)
qed "pc2_top";
*)

(* --- PC2 for pop and push ----------------------------------------- *)
(* OLD 
goal thy "pc2 r lpop apop";
by (rewrite_goals_tac [pc2_def, lpop_def, apop_def]);
bw r_def;
auto();
qed "pc2_pop";
*)

(* OLD
goal thy "pc2 r lpush apush";
by (rewrite_goals_tac [pc2_def, lpush_def, apush_def]);
bw r_def;
auto();
qed "pc2_push";
*)

(* --- PC3 for top -------------------------------------------------- *)
(* OLD
goal thy "pc3 r ltop atop";
by (rewrite_goals_tac [pc3_def, ltop_def, atop_def]);
bw r_def;
auto();
be allE 1;
be impE 1;
br trans 2;
br (hd_0th RS sym) 3;
auto();
qed "pc3_top";
*)

(* --- PC3 for push ------------------------------------------------ *)
(* OLD
goal thy "pc3 r lpush apush";
(* Not this: by (rewrite_tac [pc3_def, apush_def, lpush_def]);  but :*)
bw pc3_def;
bw apush_def;
bw lpush_def;
auto();

br (r_same_elems RS iffD2) 1;
br (elems_Cons RS sym) 1;
br (r_same_elems RS iffD1 RS sym) 1;
ba 1;

qed "pc3_push";
*)

(* --- PC3 for pop ------------------------------------------------- *)
(* OLD
goal thy "pc3 r lpop apop";
bw pc3_def;
bw apop_def;
bw lpop_def;
auto();
br (r_same_elems RS iffD2) 1;
br (elems_Tl RS sym) 1;
br (r_same_elems RS iffD1 RS sym) 1;
ba 1;
qed "pc3_pop";
*)