
(* ***************** Isar attribute ABS_TYPE setup *************** *)


signature ABSTAC_ATTRIB =
sig
 val abs_type_att_global : Args.src -> Theory.theory Thm.attribute
 val abs_type_att_local  : Args.src -> ProofContext.context Thm.attribute 
 val setup               : (Theory.theory -> Theory.theory) list
end

structure AbsTac_Attrib : ABSTAC_ATTRIB = 
struct


fun abs_type_att_trans1 tpnm thy thm =             let val _ = (AbsTac.verbose := true)
                                                       val _ =  writeln ("+++ Abstracting from type " ^ tpnm ^ ": ")
                                                      
                                                       val abs_thm = AbsTac.abs_from_type_isar tpnm thy thm;
                                           
                                                       val _ = writeln ("+++ Resulting theorem :");
                                                       val _ = writeln (string_of_thm abs_thm); 
                                                    in 
                                                      abs_thm
                                                    end

fun abs_type_att_trans2 tpnm ctx thm =             let val _ = (AbsTac.verbose := false)
 
                                                       val thy = ProofContext.theory_of ctx 
                                                       val abs_thm = AbsTac.abs_from_type_isar tpnm thy thm
                                                    in
                                                       abs_thm 
                                                   end


val abs_type_att_global = Attrib.syntax (Scan.lift (Args.name) >> (Drule.rule_attribute o abs_type_att_trans1));
val abs_type_att_local  = Attrib.syntax (Scan.lift (Args.name) >> (Drule.rule_attribute o abs_type_att_trans2));



val setup = [Attrib.add_attributes
              [("ABS_TYPE", (abs_type_att_global, abs_type_att_local),
                "abstract the theorem over the given type")]];

end;

