(* ***************** Isar attribute EXP_THMS setup *************** *)


signature EXPTHMS_ATTRIB =
sig
 val exp_thms_att_global : Args.src -> Theory.theory Thm.attribute
 val exp_thms_att_local  : Args.src -> ProofContext.context Thm.attribute 
 val setup               : (Theory.theory -> Theory.theory) list
end

structure ExpThms_Attrib : EXPTHMS_ATTRIB = 
struct

(* Parsing arguments for AbsTac.expand_thms *)

fun repeatd scan = (scan -- Scan.repeat (scan)) >> op :: || Scan.succeed []; 

val scan_exp_param_list = (repeatd Args.name);




fun exp_thms_att_trans1 exp_list thy thm =         let val _ = (AbsTac.verbose := true)
                                                       val _ =  writeln ("+++ Expanding " ^ (commas exp_list))
                                                       
                                                       val exp_thm = AbsTac.expand_thms_isar exp_list thy thm
                                                    in 
                                                      exp_thm
                                                    end

fun exp_thms_att_trans2 exp_list ctx thm =         let val _ = (AbsTac.verbose := false)
 
                                                       val thy = ProofContext.theory_of ctx 
                                                       val exp_thm = AbsTac.expand_thms_isar exp_list thy thm
                                                    in
                                                       exp_thm 
                                                   end


val exp_thms_att_global = Attrib.syntax (Scan.lift (scan_exp_param_list) >> (Drule.rule_attribute o exp_thms_att_trans1));
val exp_thms_att_local  = Attrib.syntax (Scan.lift (scan_exp_param_list) >> (Drule.rule_attribute o exp_thms_att_trans2));



val setup = [Attrib.add_attributes
              [("EXP_THMS", (exp_thms_att_global, exp_thms_att_local),
                "expand given thms in the proofterm")]];

end;
