
structure T_Instantiate =
struct

exception INSTANTIATE of string

val scan_mix = Scan.option ((OuterParse.$$$ "mixfix:") |-- OuterParse.opt_mixfix)

fun repeatd delim scan = (scan -- Scan.repeat (OuterParse.$$$ delim |-- scan )) >> op :: || Scan.succeed []; 


val scan_map_param      = (OuterParse.$$$ "(" |-- (OuterParse.string --  
                                  (OuterParse.$$$ "|->" |-- ((OuterParse.string -- scan_mix) --| 
                                  OuterParse.$$$ ")"))));

val scan_map_param_list = (OuterParse.$$$ "[" |-- (repeatd "," scan_map_param) --| OuterParse.$$$ "]");

val scan_ren_key = OuterParse.$$$ "renames:"
val scan_renames = Scan.option(scan_ren_key |-- scan_map_param_list)
val scan_syn_key = Scan.option(OuterParse.$$$ "no_syntax")


val instantiate_scan = OuterParse.name -- (OuterParse.name -- (scan_renames -- scan_syn_key))

fun inst_trans args =
     Toplevel.theory (fn thy => (let val (trgnm, (mnm, (ren, syn))) = args
                                     val thynm = Aux.name_of_thy thy

                                     val trg = (if (thynm = trgnm) then thy else (theory trgnm))
                                     
                                     val tmorph = (case (T_Toplevel.get_thymorph mnm) of
                                                    None => raise INSTANTIATE ("Unknown theory morphism " ^ mnm)
                                                   | Some m => m)
                                     
                                     val src = SigMorph.src (ThyMorph.sig_morph tmorph)

(*
                                     val incl = (if (Aux.is_parent src trg) then ThyMorph.make_inclusion src trg
                                                 else (let val _ = warning ("The domain of the theory morphism " ^ 
                                                                   mnm ^ " is not a parent of the theory " ^ trgnm )
                                                       in
                                                        ThyMorph.make_inclusion src trg
                                                       end)) 
*)
                                     val incl = ThyMorph.make_inclusion src trg                                     
                                     val tmorph' = ThyMorph.cod_ext tmorph [] thy
                                     
                                     val ntmorph = (case ren of
                                                      Some r => (case syn of
                                                                  Some s => 
                                                                   T_Toplevel.instantiate false ("", incl) (mnm, tmorph') r
                                                                 | None => 
                                                                   T_Toplevel.instantiate true ("", incl) (mnm, tmorph') r)

                                                    | None => (case syn of
                                                                  Some s => 
                                                                  T_Toplevel.instantiate false ("", incl) (mnm, tmorph') []
                                                                 | None => 
                                                                  T_Toplevel.instantiate true ("", incl) (mnm, tmorph') []))

                                     val nsigma = ThyMorph.sig_morph ntmorph
                                     val nsrc_nm = Aux.name_of_thy (SigMorph.src nsigma)
                                     val nthy = SigMorph.trg nsigma

                                     val _ = writeln ("\nConstructed theory morphism " ^ mnm ^ "' : " ^ 
                                                        nsrc_nm ^ " --> " ^ thynm ^ "\n") 

                                     val _ = T_Toplevel.add_thymorph (mnm ^ "'", ntmorph)
                                  in
                                   nthy
                                  end))

fun inst_parser tokens = instantiate_scan tokens |>> inst_trans

val instantiate_cmd = OuterSyntax.command "t_instantiate" "Instantiate the current theory" 
                         OuterSyntax.Keyword.thy_goal inst_parser;

val _ = OuterSyntax.add_keywords ["renames:", "no_syntax", "mixfix:"]; 
val _ = OuterSyntax.add_parsers [instantiate_cmd];

end