
structure Translate_Syntax =
struct

exception TRANSL_SYNTAX of string



fun transl_syn_trans tmorphnm =
       (Toplevel.theory 
          (fn thy => (let val tmorph = (case (T_Toplevel.get_thymorph tmorphnm) of
                                         Some t => t
                                        | None => raise TRANSL_SYNTAX ("Unknown theory morphism " ^ tmorphnm))
                          val tmorph' = ThyMorph.cod_ext tmorph [] thy
                          val tmorph'' = T_Toplevel.translate_syntax tmorph'
                          val sigma = ThyMorph.sig_morph tmorph''
                          val nthy = SigMorph.trg sigma

                          val _ = T_Toplevel.add_thymorph (tmorphnm, tmorph')
                      in
                       nthy
                      end)))

fun transl_syn_parser tokens = OuterParse.name tokens |>> transl_syn_trans

val transl_syn_cmd = OuterSyntax.command "translate_syntax" "Translate syntax from the source to the target of the given theory morphism" OuterSyntax.Keyword.thy_goal transl_syn_parser;

val _ = OuterSyntax.add_parsers [transl_syn_cmd];

end
