
theory Greedy_Aux = Sorting + Permutation:


consts
rem :: " 'a \<Rightarrow> 'a list \<Rightarrow> 'a list"
primrec
"rem x [] = []"
"rem x (y#ys) = (if x = y then ys else (y#(rem x ys))) "  



theorem rem_subset[rule_format] : "\<forall> x.  x mem l \<longrightarrow> (set (rem x l) \<subseteq> set l) "
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac "x=a");
apply(simp);
apply(simp);
apply(erule disjE);
apply(rule disjI1);
apply(assumption);
apply(rule disjI2);
apply(split split_if_asm);
apply(simp);
apply(drule_tac x="x" in spec);
apply(drule mp, assumption);
apply(unfold subset_def);
apply(drule_tac x="xa" in bspec);
by assumption;

theorem rem_length[rule_format] : " x mem l \<longrightarrow> Suc (length (rem x l)) = length l " 
apply(induct_tac l);
by simp_all;

theorem rem_length_less[rule_format] : " x mem l \<longrightarrow> length (rem x l) < length l " 
apply(induct_tac l);
by simp_all;

theorem rem_dist1[rule_format] : "\<not>(x mem l) \<longrightarrow> (rem x l) = l " 
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(simp);
apply(rule conjI);
apply(rule notI);
apply(erule notE);
apply(split split_if);
apply(simp);
apply(rule impI);
apply(split split_if_asm);
apply(simp);
apply(drule mp, assumption);
by assumption;




theorem rem_dist2[rule_format, OF conjI] : " (distinct l) \<and> (x mem l) \<longrightarrow> (\<not>( x mem (rem x l) )) "
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(simp);
apply(split split_if_asm);
apply(split split_if_asm);
apply(erule notE);
apply(erule ssubst);
apply(rule set_mem_eq[THEN iffD1]);
apply(assumption);
apply(erule notE);
back;
apply(rule sym);
apply(assumption);
apply(split split_if_asm);
apply(erule notE);
apply(rule sym);
apply(assumption);
apply(drule mp, assumption);
by simp;

lemma rem_aux_spec[rule_format, OF conjI] : " (x \<noteq> a) \<and> (a mem (rem x l)) \<longrightarrow> a mem l " 
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(simp only: rem.simps);
apply(split split_if_asm);
apply(simp);
apply(case_tac "a = aa");
apply(simp);
apply(drule mp);
apply(simp);
apply(split split_if_asm);
apply(erule notE);
apply(simp);
apply(assumption);
by simp;


lemma rem_aux[rule_format] : " (x mem (rem a l)) \<longrightarrow> x mem l " 
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(simp);
apply(rule impI);
apply(split split_if_asm);
apply(assumption);
apply(drule mp, simp);
by assumption;


lemma rem_aux2[rule_format, OF conjI] : " (x \<noteq> a) \<and> (a mem l) \<longrightarrow> a mem (rem x l) " 
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(simp only: rem.simps);
apply(split split_if);
apply(rule conjI);
apply(rule impI);
apply(simp);
apply(rule impI);
apply(case_tac "aa = a");
apply(simp);
apply(drule mp, simp);
by simp;

lemma rem_aux3[rule_format] : " a \<notin> set l \<longrightarrow> (\<not> a mem (rem x l)) " 
apply(induct_tac l);
apply(simp_all);
apply(clarify);
by (simp add: set_mem_eq);


theorem rem_dist3[rule_format, OF conjI] : " (distinct l) \<and> (x mem l) \<longrightarrow> distinct (rem x l) "
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(simp (no_asm));
apply(rule conjI);
apply(rule impI);
apply(simp);
apply(rule impI);
apply(drule mp);
apply(simp);
apply(split split_if_asm);
apply(erule notE);
apply(simp);
apply(assumption);
apply(rule conjI);
apply(rule notI);
apply(drule rem_aux_spec);
apply(rule set_mem_eq[THEN iffD2]);
apply(assumption);
apply(simp);
apply(erule conjE);
apply(erule notE);
apply(rule set_mem_eq[THEN iffD1]);
by assumption;

theorem rem_dist4[rule_format, OF conjI] : " (distinct l) \<and> (x mem (rem a l)) 
                                            \<longrightarrow> (x \<noteq> a \<and> x mem l)"
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac "a = aa");
apply(simp only: rem.simps);
apply(split split_if_asm);
apply(drule mp);
apply(rule conjI);
apply(simp);
apply(simp);
apply(erule conjE);
apply(subgoal_tac "\<not> (aa mem list)");
apply(drule rem_dist1);
apply(simp);
apply(simp add: set_mem_eq);
apply(simp);
apply(simp);
apply(simp);
apply(clarify);
done

theorem rem_perm[rule_format] : " x mem l \<longrightarrow> x#(rem x l) <~~> l "
apply(induct_tac l);
apply(simp);
apply(simp);
apply(intro impI);
apply(drule mp, assumption);
apply(drule_tac z="a" in Permutation.Cons);
apply(rule Permutation.trans);
prefer 2;
apply(assumption);
by(rule Permutation.swap);


theorem rem_perm2[rule_format] : " \<forall> r x. l <~~> r \<longrightarrow> rem x l <~~> rem x r "
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac r);
apply(simp);
apply(clarify);
apply(case_tac "a = aa");
apply(drule_tac x=lista in spec);
apply(drule_tac x=x in spec);
apply(drule mp, simp);
apply(simp);
apply(simp (no_asm));
apply(rule conjI);
apply(rule impI);
apply(simp);
apply(rule impI);
apply(rule conjI);
apply(rule impI);
apply(rule conjI);
apply(rule impI);
apply(simp);
apply(rule impI);
apply(subgoal_tac "a mem (aa#lista)");
apply(simp);
apply(drule rem_perm);
apply(drule_tac z1=aa in cons_perm_eq[THEN iffD2]);
back;
apply(rule_tac z1=a in cons_perm_eq[THEN iffD1]);
apply(rule Permutation.trans);
apply(assumption);
apply(rule Permutation.trans);
apply(rule perm_sym);
apply(assumption);
back;
apply(rule Permutation.trans);
apply(rule Permutation.swap);
apply(simp (no_asm));
apply(erule perm_mem);
apply(simp);
apply(rule impI);
apply(rule conjI);
apply(rule impI);
apply(subgoal_tac "aa mem (a#list)");
apply(simp);
apply(drule rem_perm);
apply(drule_tac z1=a in cons_perm_eq[THEN iffD2]);
back;
apply(rule_tac z1=aa in cons_perm_eq[THEN iffD1]);
apply(rule Permutation.trans);
prefer 2;
apply(assumption);
apply(rule Permutation.trans);
prefer 2;
apply(assumption);
apply(rule Permutation.trans);
apply(rule Permutation.swap);
apply(simp (no_asm));
apply(drule perm_sym);
apply(erule perm_mem);
apply(simp);
apply(rule impI);
apply(case_tac "x mem list");
apply(subgoal_tac "x mem (aa # lista)");
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(drule rem_perm);
apply(drule rem_perm);
apply(drule_tac z1=a in cons_perm_eq[THEN iffD2]);
back;
apply(drule_tac z1=aa in cons_perm_eq[THEN iffD2]);
back;
apply(rule_tac z1=x in cons_perm_eq[THEN iffD1]);
apply(drule_tac ys="a#list" in Permutation.trans, assumption);
apply(drule perm_sym);
back;
back;
apply(drule_tac ys="aa#lista" in Permutation.trans, assumption);
back;
apply(rule perm_sym);
apply(rule Permutation.trans);
apply(rule Permutation.swap);
apply(rule Permutation.trans);
prefer 2;
apply(rule Permutation.swap);
apply(assumption);
apply(erule perm_mem);
apply(simp);
apply(subgoal_tac "\<not> (x mem lista)");
apply(drule rem_dist1);
apply(drule rem_dist1);
apply(simp);
apply(rule notI);
apply(drule perm_sym);
apply(subgoal_tac "x mem (aa#lista)");
apply(drule perm_mem, assumption);
by(simp_all add: set_mem_eq);



theorem rem_sorted[rule_format] : " sorted le l \<longrightarrow> sorted le (rem x l) "
apply(induct_tac l);
apply(simp);
apply(rule impI);
apply(simp only: rem.simps);
apply(split split_if);
apply(rule conjI);
apply(rule impI);
apply(simp);
apply(rule impI);
apply(drule mp, simp);
apply(simp only: sorted.simps);
apply(rule conjI);
apply(clarify);
apply(case_tac "x mem list");
apply(drule rem_subset);
apply(drule_tac x=y in bspec);
apply(erule subsetD);
apply(assumption);
apply(assumption);
apply(drule rem_dist1);
by simp_all;



theorem perm_ex : " \<lbrakk> x mem l; distinct l \<rbrakk> \<Longrightarrow> 
                     (\<exists> r. (l <~~> (x#r)) \<and> (\<not>(x mem r)) \<and> (distinct r)) " 
apply(frule rem_perm);
apply(frule rem_dist2, assumption);
apply(drule rem_dist3, assumption);
apply(rule_tac x="rem x l" in exI);
apply(intro conjI);
apply(rule perm_sym);
by assumption;

theorem perm_ex2 : " x mem l \<Longrightarrow> (\<exists> r. (l <~~> (x#r))) " 
apply(drule rem_perm);
apply(rule_tac x="rem x l" in exI);
apply(rule perm_sym);
by assumption;


theorem perm_dist[rule_format, OF conjI] : " \<forall> l. distinct l \<and> (l <~~> r) \<longrightarrow> distinct r"
apply(induct_tac r);
apply(simp);
apply(clarify);
apply(subgoal_tac "a mem l");
apply(frule perm_ex);
apply(assumption);
apply(erule exE);
apply(elim conjE);
apply(drule perm_sym);
apply(drule Permutation.trans, assumption);
apply(drule cons_perm_imp_perm);
apply(drule perm_sym);
back;
apply(drule_tac x="r" in spec);
apply(drule mp, simp);
apply(simp);
apply(rule notI);
apply(erule notE);
apply(rule perm_mem);
apply(rule perm_sym);
apply(assumption);
apply(rule set_mem_eq[THEN iffD2]);
apply(assumption);
apply(rule perm_mem);
apply(rule perm_sym);
apply(assumption);
by simp;




constdefs
sublist :: "'a list \<Rightarrow> 'a list \<Rightarrow> bool"
"sublist l r \<equiv> \<forall> x. x mem l \<longrightarrow> x mem r"



lemma sublistD : " \<lbrakk> sublist l r; x mem l \<rbrakk> \<Longrightarrow> x mem r"
by(simp add: sublist_def);





lemma sublist_perm : " \<lbrakk> sublist l r; l <~~> l' \<rbrakk> \<Longrightarrow> sublist l' r"
apply(simp add: sublist_def);
apply(clarify);
apply(drule perm_sym);
apply(drule perm_mem, assumption);
apply(drule_tac x="x" in spec);
by simp;


lemma sublist_perm_b : " \<lbrakk> sublist l r; r <~~> r' \<rbrakk> \<Longrightarrow> sublist l r'"
apply(simp add: sublist_def);
apply(clarify);
apply(drule_tac x="x" in spec);
apply(drule mp, simp);
apply(erule perm_mem);
by assumption;




lemma sublist_subset : "(sublist l r) = (set l \<subseteq> set r) "
apply(rule iffI);
apply(rule subsetI);
apply(simp add: sublist_def);
apply(drule_tac x="x" in spec);
apply(simp add: set_mem_eq);
apply(simp add: sublist_def);
apply(clarify);
apply(unfold subset_def);
apply(drule_tac x="x" in bspec);
by(simp_all add: set_mem_eq);



lemma sublist_Cons : " sublist l r \<Longrightarrow> sublist (x#l) (x#r) "
apply(rule sublist_subset[THEN iffD2]);
apply(drule sublist_subset[THEN iffD1]);
apply(simp);
apply(rule subsetI);
apply(drule subsetD, assumption);
by simp;

lemma sublist_red : " \<forall> r. distinct (a#l) \<and> sublist (a#l) (a#r) \<longrightarrow> sublist l r"
apply(induct_tac l);
apply(simp add: sublist_def);
apply(clarify);
apply(unfold sublist_def);
apply(clarify);
apply(case_tac "a = aa");
apply(drule spec);
apply(drule spec);
apply(simp);
apply(case_tac "x = aa");
apply(drule_tac x="x" in spec);
apply(drule mp, simp);
apply(case_tac "x = a");
apply(erule notE);
apply(rule HOL.trans);
apply(rule sym);
apply(assumption);
apply(assumption);
apply(drule spec);
apply(simp add: set_mem_eq);
apply(subgoal_tac "x mem list");
apply(case_tac "x = a");
apply(drule spec);
apply(drule spec);
apply(simp add: set_mem_eq);
apply(drule_tac x="r" in spec);
apply(drule mp);
apply(rule conjI);
apply(simp);
apply(clarify);
apply(case_tac "xa = a");
apply(simp);
apply(drule_tac x="xa" in spec);
apply(drule mp);
apply(simp add: set_mem_eq);
apply(assumption);
apply(drule_tac x="x" in spec);
back;
apply(drule mp, assumption);
apply(assumption);
apply(drule spec);
apply(drule spec);
apply(simp add: set_mem_eq);
done




lemma sublist_trans : "\<lbrakk> sublist xs ys; sublist ys zs \<rbrakk> \<Longrightarrow> sublist xs zs"
apply(drule sublist_subset[THEN iffD1]);
apply(drule sublist_subset[THEN iffD1]);
apply(rule sublist_subset[THEN iffD2]);
by simp;


lemma subset_map : " A \<subseteq> B ==> f ` A \<subseteq> f ` B "
apply(rule subsetI);
apply(simp add: image_def);
apply(clarify);
apply(drule subsetD, assumption);
apply(rule_tac x="xa" in bexI);
apply(rule refl);
by assumption;

lemma sublist_map : " sublist xs ys \<Longrightarrow> sublist (map f xs) (map f ys) "
apply(rule sublist_subset[THEN iffD2]);
apply(drule sublist_subset[THEN iffD1]);
apply(simp);
by(erule subset_map);


lemma takeWhile_sub : " sublist (takeWhile P xs) xs "
apply(induct_tac xs);
by (simp_all add: sublist_def);

lemma dropWhile_sub : " sublist (dropWhile P xs) xs "
apply(induct_tac xs);
by (simp_all add: sublist_def);

lemma filter_sub : " sublist (filter P xs) xs "
apply(induct_tac xs);
by (simp_all add: sublist_def);

lemma rem_sub : " sublist (rem x xs) xs "
apply(induct_tac xs);
by (simp_all add: sublist_def);






consts 
subst :: "'a \<Rightarrow> 'a \<Rightarrow> 'a list \<Rightarrow> 'a list"
primrec
"subst a y [] = []"
"subst a y (x#xs) = (if (x = y) then (a#xs) else (x#(subst a y xs))) "

lemma subst0 : " subst x x xs = xs "
apply(induct_tac xs);
by simp_all;


lemma subst1a : " \<not>(x mem xs) \<longrightarrow> subst a x xs = xs"
apply(induct_tac xs);
by simp_all;

lemma subst1b : " x \<noteq> y \<and> x mem xs \<longrightarrow> x mem subst a y xs "
apply(induct_tac xs);
by simp_all;

lemma subst2a : " x mem xs \<longrightarrow> a mem (subst a x xs) "
apply(induct_tac xs);
by simp_all;

lemma subst2b : " a mem (subst a x xs) \<and> (\<not>(a mem xs)) \<longrightarrow> x mem xs  "
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(simp);
apply(rule impI);
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(drule mp, simp);
by assumption;

lemma subst2c[rule_format, OF conjI] : 
              " a \<in> set(subst x y xs) \<and> y \<in> set xs \<longrightarrow> a \<in> set (x#xs) "
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(simp only: subst.simps);
apply(split split_if_asm);
apply(clarify);
apply(simp);
apply(erule disjE);
apply(simp);
apply(simp);
apply(simp);
apply(erule disjE);
apply(erule disjE);
apply(simp);
apply(simp);
apply(erule disjE);
apply(simp);
apply(drule mp, simp);
apply(erule disjE);
apply(simp);
by simp;




lemma subst3 : " x mem xs \<and> distinct xs \<and> (a \<noteq> x) \<longrightarrow> \<not>(x mem (subst a x xs) )"
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(simp);
apply(split split_if_asm);
apply(split split_if_asm);
apply(simp);
apply(erule notE);
back;
apply(simp add: set_mem_eq);
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(simp);
done

lemma subst4_neg : " x \<noteq> y \<and> \<not>( y mem xs )\<longrightarrow> \<not>(y mem subst x a xs) "
apply(induct_tac xs);
apply(simp);
apply(rule impI);
apply(erule conjE);
apply(drule mp);
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(simp);
apply(rule notI);
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(split split_if_asm);
by simp_all;


lemma subst4 : " \<lbrakk> x \<noteq> y; y mem subst x a xs \<rbrakk> \<Longrightarrow> y mem xs "
apply(rule not_not[THEN iffD1]);
apply(rule notI);
apply(drule subst4_neg[rule_format, OF conjI], assumption);
apply(erule notE);
back;
by assumption;

lemma subst_dist : " distinct (x#xs) \<longrightarrow> distinct (subst x a xs)"
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(simp);
apply(clarify);
apply(drule set_mem_eq[THEN iffD2]);
apply(drule subst4, assumption);
apply(erule notE);
back;
apply(rule set_mem_eq[THEN iffD1]);
by assumption;


lemma subst_dist2 : " distinct (x#xs) \<Longrightarrow> distinct (a#(subst x a xs))"
apply(frule subst_dist[rule_format]);
apply(case_tac "a mem xs");
apply(case_tac "x = a");
apply(clarify);
apply(simp only: subst0);
apply(drule subst3[rule_format, OF conjI]);
apply(rule conjI);
apply(simp);
apply(assumption);
apply(simp add: set_mem_eq);
apply(frule_tac a="x" in subst1a[rule_format]);
apply(simp add: set_mem_eq);
done

lemma subst5a : " \<lbrakk> sublist (x#xs) (y#ys); x mem ys \<rbrakk> 
                 \<Longrightarrow> sublist (x#xs) (x#(subst y x ys)) "
apply(case_tac "x = y");
apply(clarify);
apply(simp add: subst0);
apply(frule_tac a="y" in subst2a[rule_format]);
apply(drule sublist_subset[THEN iffD1]);
apply(rule sublist_subset[THEN iffD2]);
apply(rule subsetI);
apply(drule subsetD, assumption);
apply(simp);
apply(erule disjE);
back;
apply(simp add: set_mem_eq);
apply(case_tac "xa = x");
apply(simp);
apply(drule_tac x="xa" in subst1b[rule_format, OF conjI]);
apply(drule set_mem_eq[THEN iffD2]);
apply(assumption);
apply(rule disjI2);
apply(rule set_mem_eq[THEN iffD1]);
by assumption;

lemma subst5b : " \<lbrakk> sublist (x#xs) (y#ys); y mem xs \<rbrakk> 
                 \<Longrightarrow> sublist (y#(subst x y xs)) (y#ys)"
apply(case_tac "x = y");
apply(clarify);
apply(simp add: subst0);
apply(frule_tac a="x" in subst2a[rule_format]);
apply(rule sublist_subset[THEN iffD2]);
apply(rule subsetI);
apply(case_tac "xa = y");
apply(simp);
apply(simp);
apply(drule set_mem_eq[THEN iffD2]);
apply(case_tac "x = xa");
apply(drule sublist_subset[THEN iffD1]);
apply(clarify);
apply(unfold subset_def);
apply(drule_tac x="x" in bspec);
apply(simp);
apply(simp);
apply(drule_tac y="xa" in subst4);
apply(assumption);
apply(drule sublist_subset[THEN iffD1]);
apply(unfold subset_def);
apply(drule_tac x="xa" in bspec);
apply(simp add: set_mem_eq);
by simp;


lemma hd_swap : " y mem xs \<and> y \<noteq> x \<longrightarrow> y#(subst x y xs) <~~> (x#xs) "  
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(case_tac "y=a");
apply(simp);
apply(simp add:Permutation.swap); 
apply(simp);
apply(rule conjI);
apply(rule impI);
apply(simp);
apply(rule impI);
apply(split split_if_asm);
apply(simp);
apply(drule mp, assumption);
apply(rule Permutation.trans);
apply(rule Permutation.swap);
apply(rule Permutation.trans);
prefer 2;
apply(rule Permutation.swap);
by simp;

lemma hd_swap2 : " y mem xs \<and> y \<noteq> x \<longrightarrow> sublist (y#(subst x y xs)) (x#xs)"  
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(case_tac "y = a");
apply(rule sublist_subset[THEN iffD2]);
apply(rule subsetI);
apply(simp);
apply(erule disjE);
apply(simp);
apply(erule disjE);
apply(simp);
apply(simp);
apply(rule sublist_subset[THEN iffD2]);
apply(drule set_mem_eq[THEN iffD1]);
apply(simp);
apply(rule conjI);
apply(rule impI);
apply(simp);
apply(rule impI);
apply(rule subsetI)
apply(case_tac "x = xa");
apply(simp);
apply(case_tac "a = xa");
apply(simp);
apply(drule set_mem_eq[THEN iffD2]);
back;
apply(drule subst4, assumption);
apply(drule set_mem_eq[THEN iffD1]);
apply(drule set_mem_eq[THEN iffD1]);
by simp;

lemma hd_swap3 : " y mem xs \<and> y \<noteq> x \<longrightarrow> sublist (x#xs) (y#(subst x y xs))"  
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(case_tac "y = a");
apply(rule sublist_subset[THEN iffD2]);
apply(rule subsetI);
apply(simp);
apply(erule disjE);
apply(simp);
apply(erule disjE);
apply(simp);
apply(simp);
apply(rule sublist_subset[THEN iffD2]);
apply(drule set_mem_eq[THEN iffD1]);
apply(simp);
apply(rule conjI);
apply(rule impI);
apply(simp);
apply(rule impI);
apply(drule mp, simp add: set_mem_eq);
apply(drule sublist_subset[THEN iffD1]);
apply(rule conjI);
apply(rule disjI2);
apply(rule disjI2);
apply(unfold subset_def);
apply(drule_tac x="x" in bspec, simp);
apply(simp);
apply(erule disjE);
apply(simp);
apply(assumption);
apply(fold subset_def);
apply(rule subsetI);
apply(drule_tac c="xa" in subsetD);
apply(simp);
apply(simp);
apply(erule disjE);
by simp_all;



theorem sublist_perm2 : " \<forall> r. (distinct l) \<and> (distinct r) \<and> (sublist l r) \<and> (sublist r l) 
                          \<longrightarrow> l <~~> r "
apply(induct_tac l);
apply(simp add: sublist_def);
apply(clarify);
apply(rule not_not[THEN iffD1]);
apply(rule notI);
apply(drule hd_Cons_tl);
apply(drule_tac x="hd r" in spec);
apply(erule notE);
apply(erule subst);
apply(simp);
apply(clarify);
apply(case_tac r);
apply(simp add: sublist_def);
apply(drule_tac x="a" in spec);
apply(simp);
apply(clarify);
apply(frule_tac a="a" in subst_dist[rule_format]);
back;
apply(simp);
apply(clarify);
apply(case_tac "a \<noteq> aa");
apply(subgoal_tac "a mem lista");
apply(frule_tac y="a" in hd_swap[rule_format, OF conjI], assumption);
apply(frule_tac x="a" and a="aa" in subst3[rule_format, OF conjI]);
apply(simp);
apply(rule notI);
apply(simp);
apply(rule Permutation.trans);
prefer 2;
apply(assumption);
apply(drule_tac x="subst aa a lista" in spec);
apply(drule mp);
apply(rule conjI);
apply(assumption);
apply(rule conjI);
apply(rule_tac a="a" in sublist_red[rule_format]);
apply(rule conjI);
apply(simp);
apply(rule subst5a);
apply(assumption);
apply(assumption);
apply(rule_tac a="a" in sublist_red[rule_format]);
apply(rule conjI);
apply(simp add: set_mem_eq);
apply(rule subst5b);
apply(assumption);
apply(assumption);
apply(simp);
apply(drule sublist_subset[THEN iffD1]);
apply(unfold subset_def);
apply(drule_tac x="a" in bspec);
apply(simp);
apply(simp add: set_mem_eq);
apply(clarify);
apply(drule_tac x="lista" in spec);
apply(drule mp);
apply(rule conjI);
apply(assumption);
apply(rule conjI);
apply(rule_tac a="aa" in sublist_red[rule_format]);
apply(rule conjI);
apply(simp);
apply(assumption);
apply(rule_tac a="aa" in sublist_red[rule_format]);
apply(rule conjI);
apply(simp);
apply(assumption);
by assumption;


theorem sublist_perm3 : " l <~~> r \<Longrightarrow> (sublist l r) \<and> (sublist r l) "
apply(simp add: sublist_def);
apply(rule conjI);
apply(clarify);
apply(erule perm_mem);
apply(assumption);
apply(clarify);
apply(drule perm_sym);
apply(erule perm_mem);
by assumption;


theorem sorted_eq : " (\<forall> x y. le x y \<and> le y x \<longrightarrow> x = y)
                     \<Longrightarrow> 
                      \<forall> l r. l <~~> r \<and> (sorted le l) \<and> (sorted le r) 
                        \<longrightarrow> l = r " 
apply(rule allI);
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac r);
apply(simp);
apply(clarify);
apply(subgoal_tac "a = aa");
apply(rule conjI);
apply(assumption);
apply(simp);
apply(simp);
apply(rule not_not[THEN iffD1]);
apply(rule notI);
apply(frule_tac x="a" in perm_mem);
apply(simp);
apply(drule perm_sym);
apply(frule_tac x="aa" in perm_mem);
apply(simp);
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(drule_tac x="aa" in bspec);
apply(simp add: set_mem_eq);
apply(drule_tac x="a" in bspec);
apply(simp add: set_mem_eq);
apply(drule_tac x="a" in spec);
apply(drule_tac x="aa" in spec);
apply(drule mp, simp);
by simp;



lemma map_subst : " x mem l \<longrightarrow> map f (y # l) <~~> map f (x # (subst y x l)) " 
apply(induct_tac l);
apply(simp);
apply(rule impI);
apply(case_tac "x = a");
apply(simp);
apply(rule Permutation.trans);
apply(rule Permutation.swap);
apply(simp);
apply(drule mp, simp);
apply(split split_if_asm);
apply(simp);
apply(assumption);
apply(simp);
apply(rule conjI);
apply(rule impI);
apply(simp);
apply(rule impI);
apply(rule Permutation.trans);
apply(rule Permutation.swap);
apply(rule Permutation.trans);
prefer 2;
apply(rule Permutation.swap);
by simp;


lemma map_perm : " \<forall> r. (l <~~> r) \<longrightarrow> map f l <~~> map f r "
apply(induct_tac l);
apply(simp);
apply(rule allI);
apply(rule impI);
apply(case_tac r);
apply(simp);
apply(case_tac "a = aa");
apply(drule_tac x="lista" in spec);
apply(drule mp, simp);
apply(simp);
apply(subgoal_tac "a mem lista");
apply(frule_tac x="aa" in hd_swap[rule_format, OF conjI]);
apply(assumption);
apply(drule_tac y="aa" and f="f" in map_subst[rule_format]);
apply(rule Permutation.trans);
prefer 2;
apply(rule perm_sym);
apply(erule ssubst);
apply(assumption);
apply(drule_tac x="subst aa a lista" in spec);
apply(drule mp);
apply(drule perm_sym);
back;
apply(drule_tac ys="r" in Permutation.trans);
apply(erule ssubst);
apply(assumption);
apply(simp);
apply(simp);
apply(subgoal_tac "a mem (a#list)");
apply(drule perm_mem, assumption);
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(assumption);
apply(simp);
done








subsection {* Functions pos and index *}

consts 
pred :: "nat \<Rightarrow> nat"
primrec
"pred 0 = 0"
"pred (Suc n) = n"


lemma pred2[rule_format, simp] : " 0 < n \<longrightarrow> Suc(pred n) = n"
apply(induct_tac n);
by simp_all;

lemma pred3 : "Suc n \<le> i \<Longrightarrow> i - Suc n = pred (i - n)"
apply(case_tac i);
apply(simp);
apply(simp);
apply(drule Suc_diff_le);
apply(erule ssubst);
back;
by simp;


consts
pos :: "nat \<Rightarrow> 'a \<Rightarrow> 'a list \<Rightarrow> nat list"
primrec
"pos n x [] = []"
"pos n x (y#ys) = (if (x = y) then (n#(pos (Suc n) x ys)) else (pos (Suc n) x ys))"

consts
index :: " nat \<Rightarrow> 'a list \<Rightarrow> 'a option "
primrec
"index n [] = None"
"index n (x#xs) = (case n of
                     0 => Some x
                   | (Suc n') => (index n' xs)) "

constdefs
gr :: "nat \<Rightarrow> nat \<Rightarrow> bool"
"gr x y \<equiv> y < x" 


lemma pos1 : " x mem l \<longrightarrow> (\<forall> n. pos n x l \<noteq> []) "
apply(induct_tac l);
by simp_all;

lemma pos1_cps : " pos n x l = [] \<Longrightarrow> \<not>(x mem l) "
apply(rule notI);
apply(drule pos1[rule_format]);
apply(erule notE);
by assumption;


lemma pos1_dist_aux : " distinct (x#xs) \<longrightarrow> (\<forall> n. pos n x xs = []) "
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(drule mp, simp);
by simp;

lemma pos1_dist : " distinct l \<and> x mem l \<longrightarrow> 
                    (\<forall> n. \<exists>! m. (n \<le> m) \<and> (pos n x l = [m])) "
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac "x = a");
apply(clarify);
apply(drule_tac n="Suc n" in pos1_dist_aux[rule_format]);
apply(rule_tac a="n" in ex1I);
apply(simp);
apply(erule conjE);
apply(simp);
apply(drule mp, simp);
apply(split split_if_asm);
apply(simp);
apply(assumption);
apply(drule_tac x="Suc n" in spec);
apply(clarify);
apply(rule_tac a="m" in ex1I);
apply(simp);
apply(erule conjE);
by simp;

lemma pos2 : "\<forall> n. pos n x xs \<noteq> [] \<longrightarrow> x mem xs" 
apply(induct_tac xs);
apply(simp);
apply(simp);
apply(intro impI);
apply(drule mp);
apply(drule mp);
apply(rule notI);
apply(simp);
apply(erule exE);
apply(rule_tac x="Suc n" in exI);
by assumption;

lemma pos2_cps : "(\<not>(x mem xs)) \<Longrightarrow> pos n x xs = []"
apply(rule not_not[THEN iffD1]);
apply(rule notI);
apply(drule pos2[rule_format]);
apply(erule notE);
by assumption;


lemma pos_r_shift : " \<forall> n xs. pos n x l = xs \<longrightarrow> pos (Suc n) x l = (map Suc xs) "
apply(induct_tac l);
apply(simp);
apply(intro allI);
apply(rule impI);
apply(simp only: pos.simps);
apply(split split_if);
apply(rule conjI);
apply(rule impI);
apply(split split_if_asm);
apply(erule_tac t="xs" in subst);
apply(simp (no_asm));
apply(erule notE);
apply(assumption);
apply(rule impI);
apply(split split_if_asm);
apply(erule notE);
apply(assumption);
apply(erule_tac t="xs" in subst);
by (rule refl);



lemma pos_r_shift2 : " i mem pos n x l \<Longrightarrow> (Suc i) mem (pos (Suc n) x l) "
apply(insert pos_r_shift[rule_format, OF refl, of "n" "x" "l"]);
apply(erule ssubst);
apply(rule set_mem_eq[THEN iffD2]);
apply(drule set_mem_eq[THEN iffD1]);
by simp;



lemma pos3 : "\<forall> n. y mem (pos n x xs) \<longrightarrow> n \<le> y" 
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(case_tac "x = a");
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(drule_tac x="Suc n" in spec);
apply(drule mp, assumption);
apply(simp);
apply(simp);
apply(drule_tac x="Suc n" in spec);
apply(drule mp, assumption);
by simp;


lemma pos_distinct : " \<forall> xs x n. distinct (pos n x xs) "
apply(rule allI);
apply(rule allI);
apply(induct_tac xs);
apply(simp);
apply(rule allI);
apply(simp only: pos.simps);
apply(split split_if);
apply(rule conjI);
apply(rule impI);
apply(drule_tac x="Suc n" in spec);
apply(simp);
apply(rule notI);
apply(drule set_mem_eq[THEN iffD2]);
apply(drule pos3[rule_format]);
apply(simp);
apply(rule impI);
apply(drule_tac x="Suc n" in spec);
by assumption;



lemma pos_sorted : "\<forall> xs x n. sorted op < (pos n x xs)"
apply(rule allI);
apply(induct_tac xs);
apply(simp);
apply(intro allI);
apply(simp (no_asm));
apply(rule conjI);
apply(rule impI);
apply(rule conjI);
apply(rule ballI);
apply(drule set_mem_eq[THEN iffD2]);
apply(drule pos3[rule_format]);
apply(simp);
apply(drule spec);
apply(drule spec);
apply(assumption);
apply(rule impI);
apply(drule_tac x="x" in spec);
apply(drule_tac x="Suc n" in spec);
by assumption;

lemma sorted_rev : " sorted op < xs \<longrightarrow> sorted gr (rev xs) "
apply(induct_tac xs);
apply(simp);
apply(rule impI);
apply(simp);
apply(clarify);
apply(drule_tac x="x" in bspec, assumption);
by (simp add: gr_def);

lemma pos_sorted_rev : " \<forall> n x xs. sorted gr (rev (pos n x xs)) "
apply(intro allI);
apply(rule sorted_rev[rule_format]);
by (rule pos_sorted[rule_format]);


lemma pos4 : "\<forall> n. y mem (pos n x xs) \<longrightarrow> y < (length xs + n)" 
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(simp);
apply(split split_if_asm);
apply(case_tac "n = y");
apply(simp);
apply(drule_tac x="Suc n" in spec);
apply(drule mp, simp);
apply(simp);
apply(drule_tac x="Suc n" in spec);
apply(drule mp, assumption);
by simp;


lemma pos_subst : " \<forall> n. x mem xs \<and> a \<noteq> x \<longrightarrow> 
                      length(pos n x xs) = Suc (length (pos n x (subst a x xs))) " 
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(simp (no_asm));
apply(rule conjI);
apply(rule impI);
apply(erule notE);
apply(assumption);
apply(rule impI);
apply(rule conjI);
apply(clarify);
apply(rule impI);
apply(rule conjI);
apply(rule impI);
apply(rule conjI);
apply(clarify);
apply(rule impI);
apply(drule_tac x="Suc n" in spec);
apply(drule mp, simp);
apply(assumption);
apply(clarify);
apply(drule_tac x="Suc n" in spec);
apply(drule mp, simp);
by(assumption);



(* *** index *** *) 

lemma index1 : "(x mem l) \<longrightarrow> (\<exists> i. (i < length l) \<and> (Some x = index i l))"
apply(induct_tac l);
apply(simp);
apply(rule impI);
apply(case_tac "a = x");
apply(rule_tac x="0" in exI);
apply(simp);
apply(drule mp, simp);
apply(clarify);
apply(rule_tac x="Suc i" in exI);
by simp;

lemma index2a : " \<forall> i. index i l = Some x \<longrightarrow> x mem l "
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac i);
apply(simp);
apply(drule_tac x="nat" in spec);
by simp;

lemma index2b : " \<forall> i. index i l = Some x \<longrightarrow> i < length l "
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac i);
apply(simp);
apply(drule_tac x="nat" in spec);
by simp;


lemma index3 : "\<forall> n. n < length l \<longrightarrow> (\<exists> x. index n l = Some x)"
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac n);
apply(rule_tac x="a" in exI);
apply(simp);
apply(drule_tac x="nat" in spec);
apply(drule mp, simp);
apply(erule exE);
apply(rule_tac x="x" in exI);
by simp;

 

lemma index_sorted[rule_format, OF conjI] : 
                     " \<forall> i j. (sorted le xs) \<and> (index i xs = Some x) \<and> (index j xs = Some y)
                                      \<and> (i < j)
                       \<longrightarrow> le x y "
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(case_tac i);
apply(case_tac j);
apply(simp);
apply(simp only: sorted.simps);
apply(erule conjE);
apply(drule_tac x="y" in bspec);
apply(simp);
apply(drule index2a[rule_format]);
apply(simp add: set_mem_eq);
apply(simp);
apply(case_tac j);
apply(simp);
apply(drule_tac x="nat" in spec);
apply(drule_tac x="nata" in spec);
apply(drule mp, simp);
by assumption;



subsection {* Mutual properties of pos and index *}

lemma pos_index : " \<forall> n. i mem (pos n x l) \<longrightarrow> index (i - n) l = Some x " 
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac "x = a");
apply(simp);
apply(split nat.split);
apply(rule conjI);
apply(split split_if_asm);
apply(simp);
apply(simp);
apply(clarify);
apply(split split_if_asm);
apply(simp);
apply(frule pos3[rule_format]);
apply(drule_tac x="Suc n" in spec);
apply(drule mp, assumption);
apply(drule pred3);
apply(drule subst);
apply(assumption);
back;
back;
back;
apply(simp);
apply(drule_tac x="Suc n" in spec);
apply(simp);
apply(split nat.split);
apply(rule conjI);
apply(rule impI);
apply(drule pos3[rule_format]);
apply(simp);
apply(clarify);
apply(drule pos3[rule_format]);
apply(drule pred3);
by simp;

lemmas pos_index_spec = pos_index[rule_format, of _ "0", simplified];


lemma index_pos_aux : "\<lbrakk> i = Suc i'; n < i; i - n = Suc n' \<rbrakk> \<Longrightarrow> i' - n = n' " 
apply(clarify);
apply(rule Suc_inject);
apply(rule HOL.trans);
apply(rule sym);
apply(rule Suc_diff_le);
apply(simp);
by assumption;

lemma index_pos : " \<forall> n i. n \<le> i \<and> index (i - n) l = Some x \<longrightarrow> i mem (pos n x l) " 
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac "i = n");
apply(simp);
apply(drule le_imp_less_or_eq);
apply(erule disjE);
prefer 2;
apply(simp);
apply(simp (no_asm));
apply(rule conjI);
apply(simp);
apply(rule impI);
apply(rule conjI);
apply(rule impI);
apply(simp only: index.simps);
apply(split nat.split_asm);
apply(simp);
apply(case_tac i);
apply(simp);
apply(drule_tac x="n" in spec);
apply(drule_tac x="nata" in spec);
apply(drule mp);
apply(rule conjI);
apply(simp);
apply(drule_tac i="i" in index_pos_aux);
apply(assumption);
apply(assumption);
apply(simp);
apply(drule pos_r_shift2);
apply(simp);
apply(rule impI);
apply(simp only: index.simps);
apply(split nat.split_asm);
apply(simp);
apply(case_tac i);
apply(simp);
apply(drule_tac x="n" in spec);
apply(drule_tac x="nata" in spec);
apply(drule mp);
apply(rule conjI);
apply(simp);
apply(drule_tac i="i" in index_pos_aux);
apply(assumption);
apply(assumption);
apply(simp);
apply(drule pos_r_shift2);
apply(simp);
done

lemmas index_pos_spec = index_pos[rule_format, OF conjI, of "0", simplified];

theorem index_pos_corr : " (index i xs = Some x) = (i mem pos 0 x xs) " 
apply(rule iffI);
apply(erule index_pos_spec);
by (erule pos_index_spec);


theorem pos_append[rule_format] : " \<forall> n. pos n x (xs @ ys) = (pos n x xs) @ (pos (n + length xs) x ys) " 
apply(induct_tac xs);
apply(simp);
apply(rule allI);
apply(simp (no_asm));
apply(rule conjI);
apply(clarify);
apply(drule_tac x="Suc n" in spec);
apply(simp);
apply(clarify);
apply(drule_tac x="Suc n" in spec);
apply(simp);
done

theorems pos_append0 = pos_append[of "0", simplified];


consts 
pos_split :: " nat \<Rightarrow> 'a list \<Rightarrow> ('a list \<times> 'a list) "
primrec
"pos_split n [] = ([], [])"
"pos_split n (x#xs) = (case n of
                        0 \<Rightarrow> ([x], xs)
                       | Suc n' \<Rightarrow> (let (l, r) = pos_split n' xs
                                               in
                                                (x#l, r))) "

lemma pos_split0[rule_format] : 
            " \<forall> n. n < length xs \<longrightarrow> xs = (fst (pos_split n xs)) @ (snd (pos_split n xs)) " 
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(simp (no_asm));
apply(split nat.split);
apply(rule conjI);
apply(simp);
apply(clarify);
apply(simp (no_asm) add: Let_def split_def);
apply(drule_tac x="nat" in spec);
by simp;

lemma pos_split1[rule_format] : " \<forall> n. n < length xs \<longrightarrow> length (fst (pos_split n xs)) = Suc n" 
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(simp (no_asm));
apply(split nat.split);
apply(rule conjI);
apply(simp);
apply(clarify);
apply(simp (no_asm) add: Let_def split_def);
apply(drule_tac x="nat" in spec);
by simp;

lemma pos_split2 : " n < length xs \<Longrightarrow> Suc n + length (snd (pos_split n xs)) = length xs" 
apply(frule pos_split0);
apply(erule ssubst);
back;
apply(drule pos_split1);
by simp;



lemma sublist_length0[rule_format, OF conjI] : 
                       " \<forall> r. distinct l \<and> length l = length r \<and> sublist l r 
                          \<longrightarrow> (sublist r l)"
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac r);
apply(simp);
apply(clarify);
apply(case_tac "aa = a");
apply(clarify);
apply(drule_tac x=lista in spec);
apply(drule mp, simp);
apply(simp add: sublist_def);
apply(clarify);
apply(drule_tac x=x in spec);
apply(drule mp);
apply(split split_if);
apply(rule conjI);
apply(simp add: set_mem_eq);
apply(simp);
apply(split split_if_asm);
apply(simp add: set_mem_eq);
apply(simp);
apply(rule sublist_subset[THEN iffD2]);
apply(drule sublist_subset[THEN iffD1]);
apply(drule sublist_subset[THEN iffD1]);
apply(rule subsetI);
apply(case_tac "x=a");
apply(clarify);
apply(simp);
apply(drule_tac c=x in subsetD);
back;
apply(simp);
apply(simp);
apply(subgoal_tac "a mem (a#list)");
apply(frule sublistD);
apply(assumption);
apply(simp);
apply(frule_tac y=a and x=aa in hd_swap[rule_format, OF conjI]);
apply(clarify);
apply(drule perm_sym);
apply(frule sublist_perm_b, assumption);
apply(drule_tac x="subst aa a lista" in spec);
apply(drule mp);
apply(rule conjI);
apply(drule perm_length);
apply(simp);
apply(rule sublist_subset[THEN iffD2]);
apply(drule sublist_subset[THEN iffD1]);
apply(drule sublist_subset[THEN iffD1]);
apply(rule subsetI);
apply(case_tac "x = a");
apply(simp);
apply(drule_tac c=x in subsetD);
back;
apply(simp);
apply(simp);
apply(drule perm_sym);
apply(rule sublist_perm);
prefer 2;
apply(assumption);
apply(simp (no_asm) add: sublist_def);
apply(clarify);
apply(drule sublistD);
back;
back;
apply(assumption);
apply(assumption);
by simp;

(*
lemma sublist_length1: " \<lbrakk> distinct l; length l = length r; sublist l r \<lbrakk> 
                          \<Longrightarrow> distinct r"
*)


lemma sublist_length1[rule_format, OF conjI] : 
                     " distinct r \<and> length l < length r \<longrightarrow> (\<not> sublist r l)"
apply(induct_tac r);
apply(simp);
apply(clarify);
apply(case_tac "length list = length l");
apply(simp);
apply(erule conjE);
apply(subgoal_tac "sublist list l");
apply(frule sublist_length0);
apply(rule conjI);
apply(assumption);
apply(assumption);
apply(frule_tac ys=l in sublist_trans);
apply(assumption);
apply(subgoal_tac "a mem (a#list)");
apply(drule_tac r=list in sublistD);
back;
apply(assumption);
apply(simp add: set_mem_eq);
apply(simp);
apply(rule sublist_subset[THEN iffD2]);
apply(drule sublist_subset[THEN iffD1]);
apply(simp);
apply(drule mp);
apply(rule conjI);
apply(simp);
apply(simp);
apply(erule notE);
back;
apply(rule sublist_subset[THEN iffD2]);
apply(drule sublist_subset[THEN iffD1]);
by simp;







end


