
theory Greedy_Aux3 = Greedy_Aux2 : 


subsubsection{* Advanced properties of pos and index *}


constdefs
pos_eqv :: "'a list \<Rightarrow> (nat \<times> nat) \<Rightarrow> bool"
"pos_eqv l \<equiv> \<lambda>(n, m). (\<exists> x. (n mem (pos 0 x l) \<and> m mem (pos 0 x l)))"

ind_inv_img :: "'a list \<Rightarrow> (nat \<times> nat) \<Rightarrow> bool"
"ind_inv_img l \<equiv> \<lambda>(i, j). (\<exists> x. index i l = Some x \<and> index j l = Some x)"

lemma pos_eqv1 : " (pos_eqv l (n, m)) = (ind_inv_img l (n, m)) "  
apply(simp add: pos_eqv_def ind_inv_img_def);
apply(rule iffI);
apply(clarify);
apply(drule index_pos_corr[THEN iffD2]);
apply(drule index_pos_corr[THEN iffD2]);
apply(rule_tac x="x" in exI);
apply(simp);
apply(clarify);
apply(drule index_pos_corr[THEN iffD1]);
apply(drule index_pos_corr[THEN iffD1]);
apply(rule_tac x="x" in exI);
by(simp);

lemma pos_eqv_refl : " n < length l \<Longrightarrow> pos_eqv l (n, n) "  
apply(rule pos_eqv1[THEN iffD2]);
apply(simp add: ind_inv_img_def);
by(erule index3[rule_format]);

lemma pos_eqv_sym : " pos_eqv l (n, m) \<Longrightarrow> pos_eqv l (m, n) "  
apply(rule pos_eqv1[THEN iffD2]);
apply(drule pos_eqv1[THEN iffD1]);
apply(simp add: ind_inv_img_def);
apply(clarify);
by simp;

lemma pos_eqv_trans : " \<lbrakk> pos_eqv l (n, p); pos_eqv l (p, m) \<rbrakk> \<Longrightarrow> pos_eqv l (n, m) "  
apply(rule pos_eqv1[THEN iffD2]);
apply(drule pos_eqv1[THEN iffD1]);
apply(drule pos_eqv1[THEN iffD1]);
apply(simp add: ind_inv_img_def);
apply(clarify);
by simp;



constdefs
pos_eqv_cls :: " 'a list \<Rightarrow> nat list \<Rightarrow> bool "
"pos_eqv_cls l xs \<equiv> (\<forall> n m. n mem xs \<and> m mem xs \<longrightarrow> pos_eqv l (n, m))" 



constdefs
pos_map :: " 'a list \<Rightarrow> (nat list) list "
"pos_map l \<equiv> map (\<lambda> x. pos 0 x l) l"


theorem pos_map_cls1 : " xs mem (pos_map l) \<Longrightarrow> pos_eqv_cls l xs "
apply(drule set_mem_eq[THEN iffD1]);
apply(simp add: pos_map_def);
apply(simp add: pos_eqv_cls_def);
apply(clarify);
apply(simp add: pos_eqv_def);
apply(rule_tac x="x" in exI);
by simp;

theorem pos_map_cls2 : " xs mem (pos_map l) \<Longrightarrow> sorted op < xs "
apply(drule set_mem_eq[THEN iffD1]);
apply(simp add: pos_map_def);
apply(clarify);
by (simp add: pos_sorted);

theorem pos_map_cls3 : " xs mem (pos_map l) \<Longrightarrow> distinct xs "
apply(drule set_mem_eq[THEN iffD1]);
apply(simp add: pos_map_def);
apply(clarify);
by (simp add: pos_distinct);

theorem pos_map_cls4 : " \<lbrakk> xs mem (pos_map l); ys mem (pos_map l); x mem xs; x mem ys \<rbrakk> 
                        \<Longrightarrow> xs = ys "
apply(drule set_mem_eq[THEN iffD1]);
apply(drule set_mem_eq[THEN iffD1]);
apply(simp add: pos_map_def);
apply(clarify);
apply(drule index_pos_corr[THEN iffD2]);
apply(drule index_pos_corr[THEN iffD2]);
by simp;

theorem pos_map_cls5 : " xs mem (pos_map l) \<Longrightarrow> xs \<noteq> [] "
apply(drule set_mem_eq[THEN iffD1]);
apply(simp add: pos_map_def);
apply(clarify);
apply(drule set_mem_eq[THEN iffD2]);
apply(drule pos1[rule_format]);
apply(erule notE);
by assumption;

theorem pos_map_cls_not_empty: " l \<noteq> [] \<Longrightarrow> (\<exists> xs. xs mem (pos_map l)) "
apply(drule hd_Cons_tl);
apply(rule_tac x="pos 0 (hd l) l" in exI);
apply(simp add: pos_map_def);
apply(rule set_mem_eq[THEN iffD2]);
apply(simp add: image_def);
apply(rule_tac x="hd l" in bexI);
apply(rule refl);
apply(erule subst);
by simp;

theorem pos_map_cls_ex : " i < length l \<Longrightarrow> (\<exists> xs. xs mem (pos_map l) \<and> i mem xs)"
apply(drule index3[rule_format]);
apply(erule exE);
apply(drule index_pos_corr[THEN iffD1]);
apply(rule_tac x="pos 0 x l" in exI);
apply(rule conjI);
apply(simp add: pos_map_def);
apply(rule set_mem_eq[THEN iffD2]);
apply(simp add: image_def);
apply(rule_tac x="x" in bexI);
apply(rule refl);
apply(rule set_mem_eq[THEN iffD1]);
apply(rule_tac n="0" in pos2[rule_format]);
apply(rule notI);
apply(simp);
by assumption;


consts
succ_nat_list :: " nat list \<Rightarrow> bool "
primrec
"succ_nat_list [] = False"
"succ_nat_list (x#xs) = (if (xs = []) then True
                         else ((Suc x = (hd xs)) \<and> (succ_nat_list xs))) "

consts
opt_Suc :: " nat option \<Rightarrow> nat option "
primrec
"opt_Suc None = None"
"opt_Suc (Some n) = Some (Suc n)"

lemma snl1 : " \<forall> i. succ_nat_list xs \<and> (Suc i < length xs) 
                           \<longrightarrow> opt_Suc(index i xs) = index (Suc i) xs "
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(case_tac i);
apply(simp);
apply(drule hd_Cons_tl);
apply(erule_tac t="list" in subst);
back;
apply(simp);
apply(drule_tac x="nat" in spec);
apply(drule mp);
apply(rule conjI);
apply(simp);
apply(split split_if_asm);
by simp_all;

lemma snl2[rule_format, OF conjI] : 
            " sorted op < xs \<and> xs \<noteq> [] \<and> \<not> succ_nat_list xs \<longrightarrow> 
             (\<exists> a b c. (a mem xs) \<and> (c mem xs) \<and> (\<not> (b mem xs)) \<and>
                               (a < b) \<and> (b < c)) "
apply(induct_tac xs);
apply(simp);
apply(rule impI);
apply(elim conjE);
apply(simp only: succ_nat_list.simps);
apply(split split_if_asm);
apply(simp);
apply(drule de_Morgan_conj[THEN iffD1]);
apply(erule disjE);
apply(subgoal_tac "Suc a < hd list | hd list < Suc a");
prefer 2;
apply(rule disjCI);
apply(simp);
apply(erule disjE);
apply(rule_tac x="a" in exI);
apply(rule_tac x="Suc a" in exI);
apply(rule_tac x="hd list" in exI);
apply(rule conjI);
apply(simp (no_asm));
apply(rule conjI);
apply(simp);
apply(drule hd_Cons_tl);
apply(erule subst);
back;
apply(simp (no_asm));
apply(rule conjI);
apply(simp only: sorted.simps);
apply(rule notI);
apply(erule conjE);
apply(frule hd_Cons_tl);
back;
apply(drule_tac s="list" and P="\<lambda>x. sorted op < x" in ssubst);
apply(assumption);
apply(simp only: sorted.simps);
apply(erule conjE);
apply(drule_tac x="Suc a" in bspec);
back;
apply(drule set_mem_eq[THEN iffD1]);
apply(drule hd_Cons_tl);
back;
apply(drule_tac s="list" and P="\<lambda>x. Suc a : set (a # x)" in ssubst);
apply(assumption);
apply(simp);
apply(simp);
apply(rule conjI);
apply(simp (no_asm));
apply(assumption);
apply(simp only: sorted.simps);
apply(erule conjE);
apply(drule_tac x="hd list" in bspec);
apply(drule hd_Cons_tl);
back;
apply(erule subst);
apply(simp (no_asm));
apply(simp);
apply(drule mp, simp);
apply(elim exE);
apply(elim conjE);
apply(rule_tac x="aa" in exI);
apply(rule_tac x="b" in exI);
apply(rule_tac x="c" in exI);
apply(rule conjI);
apply(simp);
apply(rule conjI);
apply(simp);
apply(rule conjI);
apply(rule notI);
apply(drule set_mem_eq[THEN iffD1]);
apply(drule set_mem_eq[THEN iffD1]);
apply(drule set_mem_eq[THEN iffD1]);
apply(simp);
apply(erule disjE);
apply(erule conjE);
apply(drule_tac x="aa" in bspec, assumption);
apply(drule_tac j="aa" in less_trans, assumption);
apply(simp);
apply(simp add: set_mem_eq);
by simp;


lemma snl3[rule_format, OF conjI] : 
            " succ_nat_list xs \<and> (hd xs \<le> x) \<and> (x \<le> hd (rev xs)) 
              \<longrightarrow> x mem xs " 
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(simp);
apply(rule impI);
apply(split split_if_asm);
apply(simp);
apply(erule conjE);
apply(drule mp);
apply(rule conjI);
apply(assumption);
apply(rule conjI);
apply(simp);
apply(simp);
by assumption;





theorem sorted_pos_prop1 : " \<lbrakk> l \<noteq> []; sorted le l; 
                             (\<forall> x y. le x y \<and> le y x \<longrightarrow> x = y) \<rbrakk>
                             \<Longrightarrow> 
                             (\<forall> xs. xs mem (pos_map l) \<longrightarrow> succ_nat_list xs) "
apply(clarify);
apply(rule not_not[THEN iffD1]);
apply(rule notI);
apply(frule pos_map_cls2);
apply(frule pos_map_cls5);
apply(drule snl2);
apply(rule conjI);
apply(assumption);
apply(assumption);
apply(clarify);
apply(simp add: pos_map_def);
apply(drule set_mem_eq[THEN iffD1]);
apply(simp add: image_def);
apply(clarify);
apply(drule index_pos_corr[THEN iffD2]);
apply(drule index_pos_corr[THEN iffD2]);
apply(frule index2b[rule_format]);
back;
apply(frule_tac j=c in less_trans);
apply(assumption);
apply(drule index3[rule_format]);
back;
apply(erule exE);
apply(frule_tac i=a and j=b in index_sorted);
apply(rule conjI);
apply(assumption);
apply(rule conjI);
apply(assumption);
apply(assumption);
apply(drule_tac i=b and j=c in index_sorted);
apply(rule conjI);
apply(assumption);
apply(rule conjI);
apply(assumption);
apply(assumption);
apply(drule_tac x="x" in spec);
apply(drule_tac x="xa" in spec);
apply(drule mp, simp);
apply(clarify);
apply(drule_tac i1=b in index_pos_corr[THEN iffD1]);
by simp;




subsection {* First and last index *}

constdefs
fst_ind :: " 'a \<Rightarrow> 'a list \<Rightarrow> nat "
"fst_ind x l \<equiv> (hd (pos 0 x l)) "

last_ind :: " 'a \<Rightarrow> 'a list \<Rightarrow> nat "
"last_ind x l \<equiv> (hd (rev (pos 0 x l))) "




theorem fst_index0 : " x mem l \<Longrightarrow> fst_ind x l < length l " 
apply(simp add: fst_ind_def);
apply(subgoal_tac "hd(pos 0 x l) mem pos 0 x l");
apply(drule index_pos_corr[THEN iffD2]);
apply(drule index2b[rule_format]);
apply(assumption);
apply(drule pos1[rule_format]);
apply(drule hd_Cons_tl);
apply(erule subst);
by simp;

lemma rev_mem[THEN mp] : " x mem rev xs \<longrightarrow> x mem xs "
apply(induct_tac xs);
apply(simp);
apply(simp);
apply(intro impI);
apply(drule mp);
apply(drule set_mem_eq[THEN iffD1]);
apply(rule set_mem_eq[THEN iffD2]);
apply(simp);
apply(erule disjE);
by simp_all;

lemma mem_rev[THEN mp] : " x mem xs \<longrightarrow> x mem rev xs "
apply(induct_tac xs);
apply(simp);
apply(simp);
apply(rule conjI);
apply(rule impI);
apply(rule set_mem_eq[THEN iffD2]);
apply(simp);
apply(clarify);
apply(drule set_mem_eq[THEN iffD1]);
apply(rule set_mem_eq[THEN iffD2]);
by simp;


theorem last_index0 : " x mem l \<Longrightarrow> last_ind x l < length l " 
apply(simp add: last_ind_def);
apply(subgoal_tac "hd(rev (pos 0 x l)) mem (rev (pos 0 x l))");
apply(drule rev_mem);
apply(drule index_pos_corr[THEN iffD2]);
apply(drule index2b[rule_format]);
apply(assumption);
apply(drule pos1[rule_format]);
apply(subgoal_tac "rev (pos 0 x l) \<noteq> []");
apply(drule hd_Cons_tl);
back;
apply(erule subst);
apply(simp);
apply(rule notI);
apply(drule rev_is_Nil_conv[THEN iffD1]);
apply(erule notE);
by assumption;


lemma fst_index1_aux : " \<forall> i. x mem l \<and> i < fst_ind x l \<and> Some y = index i l
                          \<longrightarrow> y \<noteq> x "
apply(induct_tac l);
apply(simp);
apply(clarify);
apply(case_tac i);
apply(simp);
apply(simp add: fst_ind_def);
apply(drule_tac x=nat in spec);
apply(case_tac "x = a");
apply(simp);
apply(simp add: fst_ind_def);
apply(drule mp);
apply(rule conjI);
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(simp);
apply(rule conjI);
apply(simp add: fst_ind_def);
apply(split split_if_asm);
apply(simp);
apply(drule_tac n="0" and x=x and l=list in pos1[rule_format]);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(drule hd_Cons_tl);
apply(drule_tac s="pos 0 x list" in ssubst);
apply(assumption);
by simp_all;

theorem fst_index1 : " \<lbrakk> x mem l; i < fst_ind x l \<rbrakk> 
                       \<Longrightarrow> index i l \<noteq> Some x "
apply(frule fst_index0);
apply(frule index3[rule_format]);
apply(frule less_trans, assumption);
apply(frule index3[rule_format]);
back;
apply(elim exE);
apply(drule fst_index1_aux[rule_format, OF conjI]);
apply(rule conjI);
apply(assumption);
apply(rule sym);
apply(assumption);
by simp;


theorem fst_mem : " x mem l \<Longrightarrow> fst_ind x l mem pos 0 x l "
apply(simp add: fst_ind_def);
apply(drule_tac n="0" in pos1[rule_format]);
apply(drule hd_Cons_tl);
apply(erule subst);
by simp;

theorem fst_ind_index : " \<forall> x l. x mem l \<longrightarrow> index (fst_ind x l) l = Some x " 
apply(clarify);
apply(drule fst_mem);
apply(drule index_pos_corr[THEN iffD2]);
by assumption;


theorem last_mem : " x mem l \<Longrightarrow> last_ind x l mem pos 0 x l "
apply(simp add: last_ind_def);
apply(rule rev_mem);
apply(drule_tac n="0" in pos1[rule_format]);
apply(subgoal_tac "rev (pos 0 x l) \<noteq> []");
apply(drule hd_Cons_tl);
back;
apply(erule subst);
back;
apply(simp (no_asm));
apply(rule notI);
apply(drule rev_is_Nil_conv[THEN iffD1]);
apply(erule notE);
by assumption;

theorem fst_lbnd : " i mem pos 0 x l \<Longrightarrow> fst_ind x l \<le> i "
apply(case_tac "l = []");
apply(simp);
apply(subgoal_tac "pos 0 x l \<noteq> []");
apply(frule pos2[rule_format]);
apply(drule fst_mem);
back;
apply(simp add: fst_ind_def);
apply(insert pos_sorted);
apply(drule_tac x="l" in spec);
apply(drule_tac x="x" in spec);
apply(drule_tac x="0" in spec);
apply(frule hd_Cons_tl);
back;
apply(drule_tac s="pos 0 x l" and P="\<lambda> x. sorted op < x" in ssubst, assumption);
apply(simp only: sorted.simps);
apply(erule conjE);
apply(case_tac "i = hd (pos 0 x l)");
apply(erule subst);
apply(simp (no_asm));
apply(drule_tac x=i in bspec);
apply(drule hd_Cons_tl);
back;
apply(drule_tac s="pos 0 x l" and P="\<lambda> x. i mem x" in ssubst, assumption);
apply(drule set_mem_eq[THEN iffD1]);
apply(drule set_mem_eq[THEN iffD1]);
apply(drule set_mem_eq[THEN iffD1]);
apply(simp);
apply(simp);
apply(rule notI);
by simp;

theorem last_ubnd : " i mem pos 0 x l \<Longrightarrow> i \<le> last_ind x l "
apply(case_tac "l = []");
apply(simp);
apply(subgoal_tac "pos 0 x l \<noteq> []");
apply(frule pos2[rule_format]);
apply(drule last_mem);
back;
apply(simp add: last_ind_def);
apply(frule_tac mem_rev);
back;
apply(insert pos_sorted);
apply(drule_tac x="l" in spec);
apply(drule_tac x="x" in spec);
apply(drule_tac x="0" in spec);
apply(drule sorted_rev[rule_format]);
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn]);
back;
apply(assumption);
apply(frule_tac mem_rev);
apply(frule hd_Cons_tl);
back;
apply(drule_tac s="rev(pos 0 x l)" and P="\<lambda> x. sorted gr x" in ssubst, assumption);
apply(simp only: sorted.simps);
apply(erule conjE);
apply(case_tac "i = hd (rev(pos 0 x l))");
apply(erule subst);
apply(simp (no_asm));
apply(drule_tac x=i in bspec);
apply(drule hd_Cons_tl);
back;
apply(drule_tac s="rev(pos 0 x l)" and P="\<lambda> x. i mem x" in ssubst, assumption);
apply(drule_tac x1=i in set_mem_eq[THEN iffD1]);
apply(drule_tac x1=i in set_mem_eq[THEN iffD1]);
apply(drule_tac x1=i in set_mem_eq[THEN iffD1]);
apply(simp);
apply(simp add: gr_def);
apply(rule notI);
by simp;

theorem sorted_fst_mono : " \<lbrakk> sorted le l; x mem l; y mem l; le x y;
                            (\<forall> x y. le x y \<and> le y x \<longrightarrow> x = y) \<rbrakk>
                             \<Longrightarrow> fst_ind x l \<le> fst_ind y l "
apply(case_tac "x = y");
apply(clarify);
apply(rule not_not[THEN iffD1]);
apply(rule notI);
apply(drule not_leE);
apply(drule fst_mem);
apply(drule fst_mem);
apply(drule index_pos_corr[THEN iffD2]);
apply(drule index_pos_corr[THEN iffD2]);
apply(drule index_sorted);
apply(rule conjI);
apply(assumption);
back;
apply(rule conjI);
apply(assumption);
apply(assumption);
apply(drule_tac x=x in spec);
apply(drule_tac x=y in spec);
apply(drule mp, simp);
apply(erule notE);
by assumption;


theorem sorted_last_mono : " \<lbrakk> sorted le l; x mem l; y mem l; le x y;
                            (\<forall> x y. le x y \<and> le y x \<longrightarrow> x = y) \<rbrakk>
                             \<Longrightarrow> last_ind x l \<le> last_ind y l "
apply(case_tac "x = y");
apply(clarify);
apply(rule not_not[THEN iffD1]);
apply(rule notI);
apply(drule not_leE);
apply(drule last_mem);
apply(drule last_mem);
apply(drule index_pos_corr[THEN iffD2]);
apply(drule index_pos_corr[THEN iffD2]);
apply(drule index_sorted);
apply(rule conjI);
apply(assumption);
back;
apply(rule conjI);
apply(assumption);
apply(assumption);
apply(drule_tac x=x in spec);
apply(drule_tac x=y in spec);
apply(drule mp, simp);
apply(erule notE);
by assumption;


theorem sorted_fst_last : " \<lbrakk> sorted le l; x mem l; y mem l; le x y; x \<noteq> y;
                            (\<forall> x y. le x y \<and> le y x \<longrightarrow> x = y) \<rbrakk>
                             \<Longrightarrow> last_ind x l < fst_ind y l "
apply(rule not_not[THEN iffD1]);
apply(rule notI);
apply(drule last_mem);
apply(drule fst_mem);
apply(drule index_pos_corr[THEN iffD2]);
apply(drule index_pos_corr[THEN iffD2]);
apply(drule leI);
apply(drule le_imp_less_or_eq);
apply(erule disjE);
apply(drule index_sorted);
apply(rule conjI);
apply(assumption);
back;
apply(rule conjI);
apply(assumption);
apply(assumption);
apply(drule_tac x=x in spec);
apply(drule_tac x=y in spec);
apply(drule mp, simp);
apply(erule notE);
apply(assumption);
apply(erule notE);
by simp;

lemma fst_hd : " \<lbrakk> x \<noteq> a; x mem l \<rbrakk> \<Longrightarrow> 0 < fst_ind x (a#l) "  
apply(rule not_not[THEN iffD1]);
apply(rule notI);
apply(simp add: fst_ind_def);
apply(drule_tac n="Suc 0" in pos1[rule_format]);
apply(drule hd_Cons_tl);
apply(subgoal_tac "hd (pos (Suc 0) x l) mem pos (Suc 0) x l");
apply(drule pos3[rule_format]);
apply(simp);
by(erule subst, simp (no_asm));

lemma fst_hd2 : " fst_ind x (x#l) = 0 "
by (simp add: fst_ind_def);

lemma fst_hd_mono : " \<lbrakk> x mem xs; x mem ys; x \<noteq> a; x \<noteq> b; 
                                fst_ind x (a#xs) < fst_ind x (b#ys) \<rbrakk>
                      \<Longrightarrow> fst_ind x xs < fst_ind x ys "
apply(simp add: fst_ind_def);
apply(insert pos_r_shift[rule_format, OF refl, of "0" "x" "xs"]);
apply(insert pos_r_shift[rule_format, OF refl, of "0" "x" "ys"]);
apply(simp);
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule hd_Cons_tl);
apply(drule hd_Cons_tl);
apply(drule_tac s="pos 0 x xs" and P="\<lambda> x. ?F x < ?G x" in ssubst);
apply(assumption);
apply(drule_tac s="pos 0 x ys" and P="\<lambda> x. ?F x < ?G x" in ssubst);
apply(assumption);
back;
back;
by simp;




lemma mem_app_aux[simp] : " x mem (xs @ [x]) "
apply(induct_tac xs);
apply(simp_all);
done

lemma mem_app_aux2[rule_format, OF conjI] : " x mem (xs @ [a]) \<and> x \<noteq> a \<longrightarrow> x mem xs"
apply(induct_tac xs);
apply(simp_all);
done


lemma last_fst_eq_aux0a[rule_format] : " \<forall> r. l \<noteq> [] \<longrightarrow> hd (map f (l @ r)) = f (hd l) "
apply(induct_tac l);
apply(simp_all);
done

lemma last_fst_eq_aux0b[rule_format] : " \<forall> r. l \<noteq> [] \<longrightarrow> hd ((map f l) @ r) = f (hd l) "
apply(induct_tac l);
apply(simp_all);
done



lemma last_fst_eq_aux1 : "hd (rev (pos 0 x (xs @ [x]))) = length xs"
apply(induct_tac xs);
apply(simp);
apply(simp);
apply(rule conjI);
apply(clarify);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(simp add: rev_map);
apply(subgoal_tac "x mem (list @ [x])");
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn]);
apply(assumption);
apply(drule last_fst_eq_aux0b);
apply(rule HOL.trans);
apply(assumption);
apply(simp);
apply(simp);
apply(rule impI);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(simp add: rev_map);
apply(subgoal_tac "x mem (list @ [x])");
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn]);
apply(assumption);
apply(drule_tac f="Suc" and r="[]" in last_fst_eq_aux0b);
apply(rule HOL.trans);
apply(simp);
apply(rule refl);
by simp;


lemma pos_app_red : "  \<not> x mem ys 
                       \<Longrightarrow> (pos 0 x (xs @ ys)) = (pos 0 x xs) "
apply(rule HOL.trans);
apply(rule pos_append0);
apply(drule pos2[rule_format, THEN[2] contrapos_nn]);
apply(assumption);
by simp;



theorem last_fst_eq[rule_format] : " x mem l \<longrightarrow> last_ind x l + fst_ind x (rev l) + 1 = length l "
apply(induct_tac l rule: rev_induct);
apply(simp);
apply(rule impI);
apply(case_tac "x = xa");
apply(clarify);
apply(simp add: last_ind_def fst_ind_def);
apply(rule last_fst_eq_aux1);
apply(drule mem_app_aux2, assumption);
apply(drule mp, assumption);
apply(simp add: last_ind_def fst_ind_def);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(subgoal_tac "\<not> x mem [xa]");
apply(drule pos_app_red);
apply(erule ssubst);
back;
apply(drule mem_rev);
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule_tac r="[]" and f="Suc" in last_fst_eq_aux0a);
apply(simp);
apply(simp);
apply(rule notI);
by simp;

theorem last_fst_eq2 : " x mem l \<Longrightarrow> fst_ind x l + last_ind x (rev l) + 1 = length l "
apply(subgoal_tac "length l = length (rev l)");
apply(erule ssubst);
apply(drule mem_rev);
apply(drule last_fst_eq);
by simp_all;


theorem last_eq1 : " x mem l \<Longrightarrow> last_ind x l = length l - (Suc (fst_ind x (rev l))) "
apply(frule mem_rev);
apply(drule fst_index0);
back;
apply(drule Suc_leI);
apply(drule le_imp_diff_is_add[THEN iffD2]);
apply(rule sym);
apply(drule last_fst_eq);
apply(simp);
by simp;



subsection {* Positions and remove *}


lemma fst_pos_shift : " \<lbrakk> x mem l; x \<noteq> a \<rbrakk>
                       \<Longrightarrow> fst_ind x l < fst_ind x (a#l) "
apply(case_tac l);
apply(simp);
apply(clarify);
apply(case_tac "aa = x");
apply(clarify);
apply(simp add: fst_ind_def);
apply(simp add: fst_ind_def);
apply(rule impI);
apply(drule_tac n=0 in pos1[rule_format]);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(drule hd_Cons_tl);
apply(erule subst);
by simp;


lemma fst_rem_pos1[rule_format, OF conjI] : 
                  " x mem xs \<and> x \<noteq> a \<longrightarrow> fst_ind x (rem a xs) \<le> fst_ind x xs "
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(case_tac "aa = x");
apply(clarify);
apply(simp);
apply(rule conjI);
apply(rule impI);
apply(simp);
apply(rule impI);
apply(simp add: fst_hd2);
apply(drule mp, simp);
apply(simp);
apply(rule conjI);
apply(clarify);
apply(drule fst_pos_shift);
apply(assumption);
apply(simp);
apply(rule impI);
apply(simp add: fst_ind_def);
apply(clarify);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(subgoal_tac "x mem (rem a list)");
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule hd_Cons_tl);
apply(drule hd_Cons_tl);
apply(rule subst, assumption);
apply(rule_tac t="pos 0 x (rem a list)" in subst, assumption);
apply(simp (no_asm));
apply(rule rem_aux2);
apply(clarify);
by assumption;


(*
lemma fst_rem_pos2[rule_format, OF conjI] : 
                  " x mem rem a xs \<and> distinct xs \<longrightarrow> fst_ind x (rem a xs) \<le> fst_ind x xs "
apply(case_tac "x = a");
prefer 2;
apply(clarify);
apply(drule rem_aux);
apply(erule fst_rem_pos1);
apply(assumption);
apply(induct_tac xs);
apply(simp);
apply(clarify);
*)



lemma last_rem_pos1[rule_format, OF conjI] : 
                  " x mem xs \<and> x \<noteq> a \<longrightarrow> last_ind x (rem a xs) \<le> last_ind x xs "
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(case_tac "aa = x");
apply(clarify);
apply(simp add: last_ind_def);
apply(rule conjI);
apply(clarify);
apply(clarify);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(simp add: rev_map);
apply(case_tac "x mem list");
apply(frule_tac n=0 in pos1[rule_format]);
apply(drule_tac x=a and l=list in rem_aux2);
apply(assumption);
apply(drule_tac n=0 in pos1[rule_format]);
back;
apply(drule mp, assumption);
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn], assumption);
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn], assumption);
apply(drule_tac r="[0]" and f="Suc" in last_fst_eq_aux0b);
apply(erule ssubst);
apply(drule_tac r="[0]" and f="Suc" in last_fst_eq_aux0b);
apply(erule ssubst);
apply(simp);
apply(subgoal_tac "x \<notin> set list");
apply(drule_tac x=a in rem_aux3);
apply(drule_tac n1=0 in pos2[rule_format, THEN[2] contrapos_nn], assumption);
apply(drule_tac n1=0 in pos2[rule_format, THEN[2] contrapos_nn], assumption);
apply(simp);
apply(simp add: set_mem_eq);
apply(drule mp, simp);
apply(simp);
apply(rule conjI);
apply(clarify);
apply(simp add: last_ind_def);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(simp add: rev_map);
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn], assumption);
apply(drule_tac r="[]" and f="Suc" in last_fst_eq_aux0b);
apply(simp);
apply(rule impI);
apply(simp add: last_ind_def);
apply(rule conjI);
apply(clarify);
apply(clarify);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(simp add: rev_map);
apply(frule_tac n=0 in pos1[rule_format]);
apply(subgoal_tac "a \<noteq> x");
apply(drule_tac x=a and l=list in rem_aux2);
back;
apply(assumption);
apply(drule_tac n=0 in pos1[rule_format]);
back;
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn], assumption);
apply(drule_tac r="[]" and f="Suc" in last_fst_eq_aux0b);
back;
apply(simp);
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn], assumption);
apply(drule_tac r="[]" and f="Suc" in last_fst_eq_aux0b);
apply(simp);
apply(clarify);
done


theorem last_rem_pos[rule_format] : 
                  " x mem (rem a xs) \<longrightarrow> last_ind x (rem a xs) \<le> last_ind x xs "
apply(case_tac "x = a");
apply(induct_tac xs);
apply(simp);
apply(clarify);
apply(case_tac "a = aa");
apply(clarify);
apply(simp add: last_ind_def);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(simp add: rev_map);
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn], assumption);
apply(drule_tac r="[0]" and f="Suc" in last_fst_eq_aux0b);
apply(simp);
apply(simp);
apply(split split_if_asm);
apply(simp);
apply(simp add: last_ind_def);
apply(simp add: pos_r_shift[rule_format, OF refl]);
apply(simp add: rev_map);
apply(frule rem_aux);
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule_tac n=0 in pos1[rule_format]);
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn], assumption);
apply(drule_tac r="[]" and f="Suc" in last_fst_eq_aux0b);
back;
apply(simp);
apply(drule rev_is_Nil_conv[THEN iffD1, THEN[2] contrapos_nn], assumption);
apply(drule_tac r="[]" and f="Suc" in last_fst_eq_aux0b);
apply(simp);
apply(rule impI);
apply(drule rem_aux);
apply(drule last_rem_pos1);
apply(assumption);
apply(assumption);
done


theorem last_f_rem_pos[rule_format] : 
                  "x mem (f_rem xs l) \<longrightarrow> last_ind x (f_rem xs l) \<le> last_ind x l "
apply(induct_tac xs);
apply(simp add: f_rem_def);
apply(clarify);
apply(simp add: f_rem_def);
apply(fold f_rem_def);
apply(drule mp);
apply(erule rem_aux);
apply(rule le_trans);
apply(rule last_rem_pos);
by assumption;


theorem last_of_last : " last_ind x (l @ [x]) = length l "
apply(simp add: last_ind_def);
apply(simp add: pos_append);
done

lemma last_of_last_neq : "\<lbrakk> x mem l; x \<noteq> y \<rbrakk> \<Longrightarrow> last_ind x (l @ [y]) < length l "
apply(simp only: last_ind_def);
apply(simp only: pos_append);
apply(simp);
apply(fold last_ind_def);
by (erule last_index0);


theorem last_of_last_neq2 : "\<lbrakk> x mem l; x \<noteq> y \<rbrakk> 
                             \<Longrightarrow> last_ind x (l @ [y]) = last_ind x l "
apply(simp only: last_ind_def);
by(simp add: pos_append);






end