header {* An exception monad *}

theory Exn = Main: 

datatype 'a exn = Error string | Just 'a

thymorph s_exn : MonadType --> Exn
  maps [("MonadType.M" |-> "Exn.exn")] [] []

t_instantiate MonadOpBind s_exn
 
primrec
  "((Error e) >>= f) = Error e"
  "((Just v) >>= f) = f v"

lemma exn_lunit:  "(Just x >>= t) = t x" by simp;

lemma exn_runit:  "(t >>= Just) = t"
apply(case_tac t);
by (simp_all);

lemma exn_assoc:  "(s >>= t >>= u) = (s >>= (%x. t x >>= u))" 
apply(case_tac s);
by (simp_all);

lemma exn_inj: "Just x= Just y ==> x= y" by simp;

thymorph t_exn: MonadAxms --> Exn
   maps [("MonadType.M" |-> "Exn.exn")] [] []

t_instantiate Monad t_exn;

text{* Raising and handling errors *}

constdefs 
  raise  :: "string=> 'a exn"
 "raise e == Error e"

consts
  handle :: "'a exn=> (string=> 'a)=> 'a"

primrec
  "handle (Just v) f  = v"
  "handle (Error e) f = f e" 
           
end
