
theory Option = Main:

thymorph montp_opt : MonadType --> Option
  maps [("MonadType.M" |-> "Datatype.option")] 
       
(* We need only the const bind, so we get it by instantiation. 
   Const eta is already given by Datatype.option.Some *)
t_instantiate MonadOpBind montp_opt

(* Now we can define the bind operation and 
   prove the monad properties *)
primrec
"(None >>= f) = None"
"((Some x) >>= f) = f x" 


lemma opt_lunit:  "(Some x >>= t) = t x" by simp;

lemma opt_runit:  "(t >>= Some) = t"
apply(case_tac t);
by (simp_all);

lemma opt_assoc:  "(s >>= t >>= u) = (s >>= (%x. t x >>= u))" 
apply(case_tac s);
by (simp_all);

lemma opt_inj: "Some x= Some y ==> x= y" by simp;

(* Now we can construct the theory morphism from MonadAxms to Option ... *) 
thymorph mon_opt : MonadAxms --> Option
  maps [("MonadType.M" |-> "Datatype.option")] 

(* ... and instantiate the monad *)
t_instantiate Monad mon_opt

translate_thm "Monad.mapF_joinF'" as "" along mon_opt'; 

end
