header {* An implementation of the state monad as a state transformer *}

theory STMap0 = Main:

typedecl v

types S     = "(nat* (nat ~=> v))"
      ref   = nat
      'a st = "S => ('a* S)"

(*
thymorph s : MonadType --> STMap0 maps [("MonadType.M" |-> "STMap0.st")] [] []

t_instantiate mon_ops s
*)

consts
  bind  :: "'a st => ('a => 'b st) => 'b st"  ("_ >>=\ _" [5, 6] 5)
  eta   :: "'a => 'a st" 

defs  
  bind_def: "bind f g == split g o f"
  eta_def:  "eta x    == %s. (x, s)"

text{* The monad axioms. *}
lemma mon_lunit:  "(eta x >>= t) = t x"
  by (simp add: bind_def eta_def split_def comp_def) 

lemma mon_runit:  "(t >>= eta)   = t" 
  apply (simp add: bind_def eta_def split_def comp_def)
  done

lemma mon_assoc:  "(s >>= t >>= u) = (s >>= (%x. t x >>= u))" 
  apply (simp add: bind_def split_def comp_def)
  done

lemma help: "!!c.(a, c)= (b, c) ==> a = b"
  by (simp add: split_tupled_all)

ML 
{* (* Can't get this to work in Isar: *)
  bind_thm ("help2", read_instantiate_sg (sign_of (theory ("Main"))) 
            [("f", "Pair a"), ("g", "Pair b")] fun_cong RS (thm "help")); 
 *}

lemma mon_eta_inj: "eta x= eta y ==> x= y"
  apply (simp add: eta_def)
  apply (rule help2)
  by simp

constdefs
  lookup :: "ref => v st"
 "lookup r == %s. (case (snd s) r of None => arbitrary | Some b=> b, s)"

  upd    :: "ref => v => unit st"
 "upd r v  == %s. ((), (fst s, (snd s) (r|-> v)))"

  ref    :: "v=> ref st"
 "ref v == %s. (fst s+ 1, (fst s+ 1, snd s (fst s|-> v)))"

end
