header{* Local and Global State *}

theory State = Main:

typedecl 'a S

thymorph t : MonadType --> State maps [("MonadType.M" |-> "State.S")] 

(* Here we need both consts: eta and bind 
   together with monad axioms and syntax *)
t_instantiate Monad t 

section{* References *} 

typedecl 'a ref

consts
  ref    :: "'a => ('a ref) S"
  lookup :: "'a ref=> 'a S"         ("!_"     [50] 50)
  upd    :: "'a ref=> 'a => unit S" ("_ := _" [50, 50] 50)

section{* Global State Axioms *}
 
axioms
  GS1:  "(do {v<- !r; r:= v; t}) = t"
  GS2:  "(do {v<- !r; w<- !r; t v w}) = (do {v<- !r; t v v})"
  GS3:  "(do {r := v; r:= w})    = (r := w)"
  GS4:  "(do {r := v; w<- !r; t w}) = (do {r:= v; t v})"
  GS5:  "[| r ~= s |] ==> 
          (do {v<- !r; w<- !s; t v w}) = 
          (do {w<- !s; v<- !r; t v w})"
  GS6:  "[| r ~= s |] ==> (do {r := v; s:= w}) = (do {r := w; s := v})"
  GS7:  "[| r ~= s |] ==> 
         (do {r := v; w<- !s; t v}) = (do {w<- !s; r := v; t w})"


section{* Local State Axioms *}
  
axioms
  LS1:  "(do {r<- ref v; r := w; t r}) = (do {r<- ref w; t r})"
  LS2:  "(do {r<- ref v; w<- !r; t r w}) = 
         (do {r<- ref v; t r v})"
  LS3:  "(do {r<- ref v; s<- ref w; t r s}) = 
         (do {s<- ref w; r<- ref v; t r s})"
  LS4:  "(do {r<- ref v; s:= w; t r}) = 
         (do {s := w; r<- ref v; t r})"
  LS5:  "(do {r<- ref v; w<- !s; t r w}) = 
         (do {w<- !s; r<- ref v; t r w})"

text {* Additional axioms: reducing unused local variables (\eta) and
  moving terms out of context (\xi) (last requires r not to appear free in t)
  *}

axioms 
  LS6:  "(do {r<- ref v; eta t}) = (eta t)"
  LS7:  "(do {r<- ref v; a<- t; u r a}) = (do {a<- t; r<- ref v; u r a})"

end
