
theory Concat_Inst = TailRec_nat:


subsection {* Setup *} 

subsection {* Instantiation *}

typedecl D

types string = "D list"

constdefs
app :: "string \<Rightarrow> string \<Rightarrow> string"
"app l r \<equiv> l @ r"

eps :: string
"eps \<equiv> Nil"

consts 
  concat :: " string list \<Rightarrow> string "
recdef concat "measure length"
  "concat l = (if l = [] then eps else (app (hd l) (concat (tl l)))) " 


subsection {* Proof of the four rules from TailRec parameters *}

theorem append_LOne: "app eps x = x"
  by (simp add: app_def eps_def);

theorem append_ROne: "app x eps = x"
  by (simp add: app_def eps_def);

theorem append_Assoc: "app u (app v c) = app (app u v) c" 
  by (simp add: app_def);

theorem concat_ax: "concat x = (if (x = []) then eps else (app (hd x) (concat (tl x))))"
  by (rule concat.simps);


subsection {* Defining a theory morphism from TailRec to Concat_Inst *}

thymorph tau_concat : S --> Concat_Inst
         maps [("Monoid.a" |-> "string")] 

t_instantiate TailRec tau_concat renames: [("TailRec.s2" |-> "fastcat")] 

translate_thm "TailRec.TailRec" as fastcat_eq along tau_concat'

end


