theory Foldr_Inst = TailRec_nat :

text {* Another interesting instance of TailRec is the following: *}

lemma foldr_prop: "foldr f u e = (if u = [] then e else f (hd u) (foldr f (tl u) e))"
  apply (case_tac "u")
  apply (simp, simp_all)
  done

lemma foldl_prop: "foldl f e l = (if l = [] then e else foldl f (f e (hd l)) (tl l))"
  apply (case_tac "l")
  apply (simp, simp_all)
  done

ML {* (* Should learn how to do this sort of thing in Isar(TM). *)

bind_thm("aux", simplify (simpset_of (theory "List")) 
    (read_instantiate [("sum", "%x. foldr ?nuPlus x ?Zero"), 
                       ("sum2.0", "%(x,z).foldl ?nuPlus z x")] (thm "abs_eq"))) 
    *}

theorem foldlr: assumes mleft: "!!x. f e x = x" 
                assumes mright: "!!x. f x e = x"
                assumes massoc: "!!x y z. f x (f y z) = f (f x y) z"
                shows   "foldr f l e = foldl f e l";
  apply (rule aux); 
  apply (rule foldr_prop);
  apply (rule mleft);
  apply (simp_all add: foldl_prop);
  apply (rule mright);
  apply (rule massoc);
  done

end

