theory TailRec = S+ TailRec_nat:

consts
  s2 :: " (a list \<times> a) \<Rightarrow> a "

recdef s2 "measure(\<lambda>(x, y). length x)"
  "s2 (x, y) = (if (x = Nil) then y else (s2 (tl x, p y (hd x))))"

lemma s2_Nil: " s2 (Nil, y) = y " by simp;
lemma s2_Cons: " s2 (x#xs, y) = s2 (xs, p y x) " by simp;

theorem TailRec: "s x = s2 (x, z)"
  apply (rule abs_eq)
  apply (simp add: Ax_s)
  apply (simp add: LeftOne)
  apply (rule s2.simps)
  apply (simp add: RightOne)
  apply (simp add: Assoc)
  done

end
