
theory TailRec_nat = newNat :

subsection {* Abstraction *}

consts
sum  :: "nuNat list \<Rightarrow> nuNat"
sum2 :: "(nuNat list \<times> nuNat) \<Rightarrow> nuNat"

recdef sum "measure length"
"sum l = (if l = [] then Zero else nuPlus (hd l) (sum (tl l)))"

recdef sum2 "measure (\<lambda> (l, x). length l)"
"sum2 (l, e) = (if l = [] then e else sum2 (tl l, nuPlus e (hd l)))"


lemma sum_Cons : " sum (x#xs) = nuPlus x (sum xs) " by simp;

lemma sum2_Cons : " sum2 (x#xs, a) = sum2 (xs, nuPlus a x) " by simp;

lemma nuPlus_1 : "\<forall>e. nuPlus e (sum l) = sum2 (l, e)"
apply(induct_tac l);
apply(simp);
apply(rule allI);
apply(simp (no_asm) only: sum_Cons sum2_Cons);
apply(drule_tac x="nuPlus e a" in spec);
apply(erule subst);
by (rule nuPluss_assoc);

theorem equality : " sum l = sum2(l, Zero) "
apply(insert nuPlus_1[of "l"]);
apply(drule_tac x="Zero" in spec);
by(simp);


theorems abs_eq = equality[EXP_THMS "TailRec_nat.nuPlus_1" "TailRec_nat.sum_Cons" "TailRec_nat.sum2_Cons", 
                           ABS_TYPE "newNat.nuNat"];



end






