
theory newNat = Trafo:

subsection {* New type nuNat *}
datatype nuNat =
    Zero
  | nuSuc nuNat


consts
  nuPlus :: "nuNat => nuNat => nuNat"
  nuMult :: "nuNat => nuNat => nuNat"

primrec
  "nuPlus Zero x = x"
  "nuPlus (nuSuc x) y = nuSuc (nuPlus x y)"


primrec
  "nuMult Zero x = Zero"
  "nuMult (nuSuc x) y = nuPlus y (nuMult x y)"

subsection {* Required properties of nuNat *}

theorem nuPluss_assoc[simp] : "nuPlus a (nuPlus b c) = nuPlus (nuPlus a b) c";
apply(induct_tac a);
by simp_all;

theorem nuPluss_Zero_Id_right[simp] : "nuPlus x Zero = x"
apply(induct_tac x);
by simp_all;

theorem nuPluss_nuSuc_right[simp] : "nuPlus x (nuSuc y) = nuSuc (nuPlus x y)"
apply(induct_tac x);
by simp_all;

theorem nuPluss_comm : "nuPlus a b = nuPlus b a"
apply(induct_tac a);
by simp_all;

end
